#include <avr/io.h>
#include "adc_driver.h"
#include "avr_compiler.h"
#include "KEY.h"
#include "usart.h"
#include "clksys_driver.h"
#include "TC_driver.h"
#include "OLED.h"
#include "mmc.h"

#define LED1_ON()   PORTC.OUT&=~0x01
#define LED1_OFF()  PORTC.OUT|=0x01
#define LED1_T()    PORTC.OUT^=0x01

#define LED2_ON()   PORTC.OUT&=~0x02
#define LED2_OFF()  PORTC.OUT|=0x02
#define LED2_T()    PORTC.OUT^=0x02

#define LED2_EN()    PORTC.DIR|=0x02
#define LED2_DIS()   PORTC.DIR&=~0x02

#define BELL_ON()   PORTE.OUT|=0x20
#define BELL_OFF()  PORTE.OUT&=~0x20
//--------------------------------------------------------------------
volatile int8_t offset;
unsigned char Led_count=0;
volatile int16_t sysTime=0,key_time=0,refer_flag=1,LED_PWM=0x1ff;
//--------------------------------------------------------------------
void Port_initial(void)
{
PORTD.DIR=0xAF;
PORTA.DIR&=~0x03;
PORTD.OUT|=0x1f;
PORTC.DIR|=0x03;
PORTE.DIR|=0x20;
}
//--------------------------------------------------------------------
void LED_Show(void)
{
Led_count=0;
LED1_ON();
}
//--------------------------------------------------------------------
void ADC_initial(void)
{
/* Move stored calibration values to ADC A. */
	ADC_CalibrationValues_Load(&ADCA);

	/* Set up ADC A to have signed conversion mode and 12 bit resolution. */
  	ADC_ConvMode_and_Resolution_Config(&ADCA, ADC_ConvMode_Signed, ADC_RESOLUTION_12BIT_gc);

	/* Set sample rate. */
	ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV32_gc);

	/* Set reference voltage on ADC A to be VCC/1.6 V.*/
	ADC_Reference_Config(&ADCA, ADC_REFSEL_VCC_gc); 

	/* Setup channel 0, 1, 2 and 3 with different inputs. */
	ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,
	                                 ADC_CH_INPUTMODE_SINGLEENDED_gc,
	                                 ADC_DRIVER_CH_GAIN_NONE);

	ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,
	                                 ADC_CH_INPUTMODE_SINGLEENDED_gc,
	                                 ADC_DRIVER_CH_GAIN_NONE);

   	/* Get offset value for ADC A. 
   	ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
*/
	ADC_Enable(&ADCA);
	/* Wait until common mode voltage is stable. Default clk is 2MHz and
	 * therefore below the maximum frequency to use this function. */
	ADC_Wait_8MHz(&ADCA);
 	offset = ADC_Offset_Get_Signed(&ADCA, &ADCA.CH0, false);
    ADC_Disable(&ADCA);
	
    ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, 0);
	ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, 0);
	/* Set input to the channels in ADC A 
	ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
	ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXINT_SCALEDVCC_gc, 0);
*/
	/* Setup sweep of all four virtual channels. */
	ADC_SweepChannels_Config(&ADCA, ADC_SWEEP_01_gc);

	/* Enable ADC A .*/
	ADC_Enable(&ADCA);

	/* Wait until common mode voltage is stable. Default clk is 2MHz and
	 * therefore below the maximum frequency to use this function. */
	ADC_Wait_8MHz(&ADCA);

	/* Enable free running mode. */
	ADC_FreeRunning_Enable(&ADCA);

}
//ϵͳʱ ΪڲRC 32M
//----------------------------------------------------------------------------
void sysclk_initial(void)
{
		/*  Enable internal 32 MHz ring oscillator and wait until it's
		 *  stable. Divide clock by two with the prescaler C and set the
		 *  32 MHz ring oscillator as the main clock source. 
		 */
		CLKSYS_Enable( OSC_RC32MEN_bm );
		CLKSYS_Prescalers_Config( CLK_PSADIV_1_gc, CLK_PSBCDIV_1_2_gc );  //PcΪ2ƵT016M
		do {} while ( CLKSYS_IsReady( OSC_RC32MRDY_bm ) == 0 );
		CLKSYS_Main_ClockSource_Select( CLK_SCLKSEL_RC32M_gc );
}
//------------------------------------------------------------
void Initial_SystemsClk(void)
{
//Setting Ext. OSC//XTAL_16KCLK 0.4 - 16 MHz XTAL 16K CLK
OSC.XOSCCTRL=OSC_FRQRANGE_2TO9_gc | OSC_XOSCSEL_XTAL_16KCLK_gc;
/* Turn on Ext. 8M . */
OSC.CTRL |=OSC_XOSCEN_bm;
	do {
		/* Wait for the oscillators to stabilize. */
	} while ( ( OSC.STATUS & OSC_XOSCRDY_bm ) == 0);

OSC.PLLCTRL= (uint8_t)OSC_PLLSRC_XOSC_gc | 0x2; //8M* 2=16M 
OSC.CTRL|=OSC_PLLEN_bm;  //Enable PLL
CLK.PSCTRL= (uint8_t)CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;//prescaler configuration
while((OSC.STATUS & OSC_PLLRDY_bm)==0); //Wait PLL Ready
CCP = CCP_IOREG_gc;
CLK.CTRL = CLK_SCLKSEL_PLL_gc;   //Use PLL as Main Clock

}
//----------------------------------------------------------------------------
void Timer_initial(void)
{
	/* Set period/TOP value.    */
	TC_SetPeriod( &TCD0,300);
	
	/* Enable overflow interrupt at low level */
	TC0_SetOverflowIntLevel( &TCD0, TC_OVFINTLVL_LO_gc );
	PMIC.CTRL |= PMIC_LOLVLEN_bm;

	sei();
	
	/* Select clock source. 1024 Ƶ  31.25K*/
	TC0_ConfigClockSource( &TCD0, TC_CLKSEL_DIV1024_gc);

//pwm
	/* Set period/TOP value.    */
	TC_SetPeriod( &TCC0,0x1ff);
	
	/* Enable overflow interrupt at low level*/
	TC0_SetOverflowIntLevel( &TCC0, TC_OVFINTLVL_LO_gc );
	PMIC.CTRL |= PMIC_LOLVLEN_bm; 

	TC0_ConfigWGM(&TCC0,TC_WGMODE_SS_gc);
	TC0_EnableCCChannels(&TCC0,TC0_CCBEN_bm);
	
	/* Select clock source. 2 Ƶ 16M*/
	TC0_ConfigClockSource( &TCC0, TC_CLKSEL_DIV1_gc);
}
//----------------------------------------------------------------------------
//ڳʼ384008N1@32M CPUʱ
void USART_initial(void)
{
	/* (TXD) as output. */
	PORTF.OUTSET = PIN3_bm;
	PORTF.DIRSET = PIN3_bm;
	PORTE.OUTSET = PIN7_bm;
	PORTE.DIRSET = PIN7_bm;
	/* (RXD) as input. */
	PORTF.DIRCLR = PIN2_bm;
	PORTE.DIRCLR = PIN6_bm;
	/* USART, 8 Data bits, No Parity, 1 Stop bit. */
	USART_Format_Set(&USARTE1, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 0);
	USART_Format_Set(&USARTF0, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 0);
	/* Set Baudrate to 38400 bps:
	 * Use the default I/O clock fequency that is 32 MHz.
	 * Do not use the baudrate scale factor
	 * Baudrate select = (1/(16*(((I/O clock frequency)/Baudrate)-1)
	 *                 = 25
	 */
	USART_Baudrate_Set(&USARTE1, 25 , 0);  //38400
	USART_Baudrate_Set(&USARTF0, 25 , 0);  //38400
	/* Enable both RX and TX. */
	USART_Rx_Enable(&USARTF0);
	USART_Tx_Enable(&USARTF0);
	USART_Rx_Enable(&USARTE1);
	USART_Tx_Enable(&USARTE1);
}
//--------------------------------------------------------------------
void USART_TEST(void)
{

while(1){

if(USART_IsRXComplete(&USARTF0)) //յַ
    {
	 do{
		/* Wait until it is possible to put data into TX data register.
		 * NOTE: If TXDataRegister never becomes empty this will be a DEADLOCK. */
		}while(!USART_IsTXDataRegisterEmpty(&USARTF0));
		LED_Show();
		USART_PutChar(&USARTF0, USART_GetChar(&USARTF0));
    }

if(USART_IsRXComplete(&USARTE1)) //յַ
    {
	 do{
		/* Wait until it is possible to put data into TX data register.
		 * NOTE: If TXDataRegister never becomes empty this will be a DEADLOCK. */
		}while(!USART_IsTXDataRegisterEmpty(&USARTE1));
		LED_Show();
		USART_PutChar(&USARTE1, USART_GetChar(&USARTE1));
    }
if(key_time){
if((PORTE.IN&0x1f)!=0x1f){return;}
key_time=0;
}

}
}
//--------------------------------------------------------------------
void OLED_TEST(void)
{
//display_list_char(0,0,(void*)"    OLED TEST ");
Dispay_Pic();
}
//--------------------------------------------------------------------
void ADC_TEST(void)
{

display_list_char(0,0,(void*)"   ADC  TEST ");
unsigned int ADC_CH0,ADC_CH1;
display_list_char(18,5,(void*)"CH0");
display_list_char(18,6,(void*)"CH1");

do{
		/* If the conversion on the ADCA channel 0 never is
	 * complete this will be a deadlock. */
	}while(!ADC_Ch_Conversion_Complete(&ADCA.CH0));
ADC_CH0=ADC_ResultCh_GetWord_Signed(&ADCA.CH0, offset);

do{
		/* If the conversion on the ADCA channel 0 never is
	 * complete this will be a deadlock. */
	}while(!ADC_Ch_Conversion_Complete(&ADCA.CH1));
ADC_CH1=ADC_ResultCh_GetWord_Signed(&ADCA.CH1, offset);

Display_num(0,5,ADC_CH0);
Display_Bar(26,5,(unsigned char)(ADC_CH0>>3));

Display_num(0,6,ADC_CH1);
Display_Bar(26,6,(unsigned char)(ADC_CH1>>3));
}
//--------------------------------------------------------------------
void SD_MMC_TEST(void)
{
display_list_char(0,0,(void*)"   SD/MMC TEST ");

if(mmcReset()!=0){display_list_char(0,1,(void*)"No Card!");return;}
LED_Show();
sd_raw_get_info(&cardinf);

	if(sd_raw_card_type&(1<<SD_RAW_SPEC_SDHC)){
	display_list_char(6,1,(void*)">>SDHC       ");
	}else {
	display_list_char(6,1,(void*)">>Normal SD  ");
	}

display_list_char(0,2,(void*)"SD_Size:");
Display_num(9,2,(unsigned int)cardinf.capacity);
display_list_char(9+4,2,(void*)"MB");
}
//--------------------------------------------------------------------
int main(void)
{

unsigned char key,Mode=0,lastKey=0,pwmdir=1,LED_conrst=0,delay_LED=0;
Port_initial();
BELL_ON();
LED_Show();
KEY_initial();
ADC_initial();
//sysclk_initial();
Initial_SystemsClk();
Timer_initial();
OLED_initial();
USART_initial();
mmcInit();
display_list_char(0,0,(void*)"  XMEGA_BOARD-TEST");
display_list_char(0,7,(void*)"  Press LEFT RIGHT ");
offset=0;
BELL_OFF();
sei();
while(1){

if(key_time){
	key=Get_Key();
	switch(key){
	case SELECT:     if(Mode==4)display_list_char(0,4,(void*)"  SELECT  ");LED_Show();break;
	case LEFT:       if(Mode==4)display_list_char(0,4,(void*)"  LEFT    ");LED_Show();lastKey=LEFT;break;
	case RIGHT:      if(Mode==4)display_list_char(0,4,(void*)"  RIGHT   ");LED_Show();lastKey=RIGHT;break;
	case UP:         if(Mode==4)display_list_char(0,4,(void*)"  UP      ");LED_Show();break;
	case DOWN:       if(Mode==4)display_list_char(0,4,(void*)"  DOWN    ");LED_Show();break;
	default:		 if(Mode==4)display_list_char(0,4,(void*)"Nokeypress");
					if(lastKey==LEFT){Mode++;OLED_Clear();}
					else if(lastKey==RIGHT){Mode--;OLED_Clear();}
					lastKey=0;
					if(Mode==0xff)Mode=4;if(Mode>4)Mode=0;
					break;
	}
key_time=0;
if(Mode==4){
if(delay_LED!=0){delay_LED--;}
if((pwmdir==1)&&(delay_LED==0)){
LED2_EN();
LED_PWM+=4;
if(LED_PWM>0x1fe){LED_PWM=0x1ff;pwmdir=0;delay_LED=30;}
}
else if((pwmdir==0)&&(delay_LED==0)){
LED2_EN();
LED_PWM-=4;
if(LED_PWM<0xff){LED_PWM=0xff;pwmdir=1;delay_LED=30;}
}

if(LED_PWM>0x1fe){LED_PWM=0x1fe;LED2_DIS();}
LED_conrst=(unsigned int)(0x1fe)-LED_PWM;
}
else {LED_PWM=0x1ff;pwmdir=1;LED2_DIS();}

}
if(refer_flag){
switch(Mode)
{
case 0:OLED_TEST();display_list_char(0,0,(void*)"Press LEFT RIGH Key");break;
case 1:ADC_TEST();break;
case 2:SD_MMC_TEST();break;
case 3: display_list_char(0,0,(void*)"    USART TEST ");
		display_list_char(0,2,(void*)"Bandrate:38400,n,1 ");
		display_list_char(0,4,(void*)"COMF0 COME1 Is Enable");
		display_list_char(0,7,(void*)"Press any Key T Break");
		USART_TEST();
		break;
case 4:display_list_char(0,0,(void*)"    LED-KEY TEST ");
	   display_list_char(0,2,(void*)"LED2");
	   Display_Bar(26,2,LED_conrst);
		break;
}
refer_flag=0;
}

}
return 0;
}
//--------------------------------------------------------------------
ISR(TCD0_OVF_vect)  //10mS 
{
sysTime++;
key_time=1;

if(Led_count++>15){Led_count=16;LED1_OFF();}

if(sysTime>5){
sysTime=0;
refer_flag=1;

}

}
//--------------------------------------------------------------------
ISR(TCC0_OVF_vect){

TCC0.CCBBUF=LED_PWM;

}
//End Of The File





