 #include <avr/interrupt.h>
 #include <avr/signal.h>
 #include <avr/io.h>
 #define WDR() 	asm("wdr")
 
 
//---------led operation--------
#define LED1_ON()   PORTC.OUT&=~0x01
#define LED1_OFF()  PORTC.OUT|=0x01
#define LED1_T()    PORTC.OUT^=0x01

#define LED2_ON()   PORTC.OUT&=~0x02
#define LED2_OFF()  PORTC.OUT|=0x02
#define LED2_T()    PORTC.OUT^=0x02
 
 #define SELECT   0x01
 #define LEFT     0x02
 #define RIGHT    0x04
 #define No_key  0

 #define Long_SELECT   0x08
 #define Long_LEFT     0x10
 #define Long_RIGHT    0x20



 unsigned char  Key_Time_SELECT=0,
 				Key_Time_LEFT=0,
				Key_Time_RIGHT=0;

 unsigned char Key_Return=0;

void keytimer_init(void);


 
void initial_LED_KEY(void)
 {
	PORTC.DIR|=0x03; //Set Led Pin as Output
	LED1_OFF();
	LED2_OFF();
	PORTE.DIR&=~0x1f;
	PORTE.PIN0CTRL=PORT_OPC_PULLUP_gc;
	PORTE.PIN1CTRL=PORT_OPC_PULLUP_gc;
	PORTE.PIN2CTRL=PORT_OPC_PULLUP_gc;
	PORTE.PIN3CTRL=PORT_OPC_PULLUP_gc;
	PORTE.PIN4CTRL=PORT_OPC_PULLUP_gc;
 	keytimer_init();
 }


//ʱT0ʼ
void keytimer_init(void)
{
TCC0.PER=976*4/15;  //25ms (16M/1024/4)
TCC0.INTCTRLA=TC_OVFINTLVL_LO_gc;//Enable Timer Overflow interrupt
/* Select clock source. 1024Div 16M/1024*/
TCC0.CTRLA=TC_CLKSEL_DIV1024_gc;
PMIC.CTRL |= PMIC_LOLVLEN_bm; //enable low_level interrupts
}

/*
+------------------------------------------------------------------------------
| Function    : Get_Key
+------------------------------------------------------------------------------
| Description : Test the key
|
| Parameters  : 
| Returns     : pressing key(if more than one key is pressed return 0 )
|
+------------------------------------------------------------------------------
*/
unsigned char Get_Key(void)
{
	unsigned char Key=0,num_keypress=0;
	if((PORTE.IN&(1<<1))==0){Key|=SELECT;num_keypress++;}
	if((PORTE.IN&(1<<0))==0){Key|=RIGHT;num_keypress++;}
	if((PORTE.IN&(1<<4))==0){Key|=LEFT;num_keypress++;}
	if(num_keypress>1)Key=No_key;
	return Key;
}


/*
+------------------------------------------------------------------------------
| Function    : interrput 
+------------------------------------------------------------------------------
| Description : interrput for TCC0 overflow,
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
ISR(TCC0_OVF_vect)  
{
	unsigned char Temp;
	Temp=Get_Key();
	WDR();
	if(Temp==SELECT){
					Key_Time_SELECT++;
					if(Key_Time_SELECT>40){Key_Time_SELECT=50;Key_Return=Long_SELECT;}
					Key_Time_LEFT=0;
					Key_Time_RIGHT=0;
					}
	else if(Temp==LEFT){
					Key_Time_LEFT++;
					if(Key_Time_LEFT>40){Key_Time_LEFT=50;Key_Return=Long_LEFT;}
					Key_Time_SELECT=0;
					Key_Time_RIGHT=0;	
				  }
	else if(Temp==RIGHT)
					{	
					Key_Time_RIGHT++;
					if(Key_Time_RIGHT>40){Key_Time_RIGHT=50;Key_Return=Long_RIGHT;}
					Key_Time_SELECT=0;
					Key_Time_LEFT=0;
					}
	else{
		if((Key_Time_SELECT>5)&&(Key_Time_SELECT<40)){Key_Time_RIGHT=0;Key_Time_LEFT=0;Key_Time_SELECT=0;Key_Return=SELECT;}
		else if((Key_Time_LEFT>5)&&(Key_Time_LEFT<40)){Key_Time_RIGHT=0;Key_Time_LEFT=0;Key_Time_SELECT=0;Key_Return=LEFT;}
		else if((Key_Time_RIGHT>5)&&(Key_Time_RIGHT<40)){Key_Time_RIGHT=0;Key_Time_LEFT=0;Key_Time_SELECT=0;Key_Return=RIGHT;}
		else {Key_Time_RIGHT=0;Key_Time_LEFT=0;Key_Time_SELECT=0;Key_Return=0;}
		}
}









