//-------------------------------------------------------------------------
#include	<avr/io.h>
#include 	<stdint.h>

#include	"FAT16.h"
#include	"mmc.h"
//------------------------------------------------------------------------
#define	SEC_Size				512
#define	MBR_Sector				0				//Եַ
#define	FAT_Sector				0				//߼ַ
//-------------------------------------------------------------------------
uint8_t		BUFFER[SEC_Size];
uint8_t		PB_RelativeSector=0;
uint16_t	BPB_BytesPerSec;
uint16_t	BPB_SecPerClus;
uint16_t	BPB_RsvdSecCnt;
uint8_t		BPB_NumFATs;
uint16_t	BPB_RootEntCnt;
uint16_t	BPB_TotSec16;
uint16_t	BPB_FATSz16;		 //FATռõsectors
uint16_t    DirSecCount;         //Ŀ¼ռ
uint32_t	BPB_HiddSec;         //
uint32_t    FAT_DirStartSec;     //Ŀ¼ʼַ
uint32_t    FAT_DataStartSec;    //ʼַ
File_prop   Recording_file;      //ҪļҪϢ
volatile File_prop   Reading_file;      //ҪļҪϢ
//-------------------------------------------------------------------------
uint8_t ReadBlock(uint32_t LBA){					//Եַһ
	if(mmcRead(LBA,BUFFER)!=0)return SD_FAIL;
	return SD_SUCC;
}
//-------------------------------------------------------------------------
uint8_t WriteBlock(uint32_t LBA){					//Եַдһ
	if(mmcWrite(LBA,BUFFER)!=0)return SD_FAIL;
	return SD_SUCC;
}
//-------------------------------------------------------------------------
uint8_t ReadFatBlock(uint32_t Add){					//߼ַһ
	return ReadBlock(Add+PB_RelativeSector);
}
//-------------------------------------------------------------------------
uint8_t WriteFatBlock(uint32_t Add){				//߼ַдһ
	return WriteBlock(Add+PB_RelativeSector);
}
//-------------------------------------------------------------------------
void CopyBytes(uint8_t *ps,uint8_t *pd,uint16_t size){	//ڴ濽
	for(;size;size--)*pd++=*ps++;
}
//-------------------------------------------------------------------------
uint8_t IsEqual(uint8_t *pa,uint8_t *pb,uint8_t size){	//ڴȽ
	for(;size;size--)if(*pa++!=*pb++)return 0;
	return 1;
}
//-------------------------------------------------------------------------
void EmptyBytes(uint8_t *pd,uint16_t size){			//ڴ
	for(;size;size--)*pd++ =0;
}
//-------------------------------------------------------------------------
uint8_t ReadMBR(void){									//ȡMBRݽṹ
	uint8_t ok;
	FAT_MBR * MBR=(FAT_MBR*)BUFFER;
	ok=ReadBlock(MBR_Sector);
	if(ok==SD_FAIL)return SD_FAIL;
	if(MBR->MBR_Signature!=0xAA55)return SD_FAIL;		//Ч־
		
	//ȡ
	PB_RelativeSector=MBR->MBR_pb[0].PB_RelativeSector;//߼ַԵַƫ
	return SD_SUCC;
}

//-------------------------------------------------------------------------
uint32_t DirStartSec(void){							//ȡĿ¼ʼ
	return BPB_RsvdSecCnt+BPB_NumFATs*BPB_FATSz16;   //ʼַ+FATռõĵַ=Ŀ¼ʼ
}
//-------------------------------------------------------------------------
uint16_t GetDirSecCount(void){							//Ŀ¼ռõ
	return (BPB_RootEntCnt*32)>>9;						
}
//-------------------------------------------------------------------------
uint32_t DataStartSec(void){							//ȡʼ
	return DirStartSec()+GetDirSecCount();
}
//-------------------------------------------------------------------------
uint32_t ClusConvLBA(uint16_t ClusID){					//ȡһصĿʼ
	return FAT_DataStartSec+BPB_SecPerClus*(ClusID-2);
}
//-------------------------------------------------------------------------
uint8_t ReadBPB(void){									//ȡBPBݽṹ
	
	uint16_t hidsec;
	
	
	//еsdBPB0
	for(hidsec=0;hidsec<0x1000;hidsec++)//Some card the BPB is not locat at secter 0
	{
		if(ReadBlock(hidsec)==SD_FAIL)return SD_FAIL;
		if((BUFFER[0]==0xeb) || (BUFFER[0]==0xe9))break;
	}
	if(hidsec==0x1000)return SD_FAIL; //error maybe the card hasn't been formated
	
	FAT_BPB * BPB=(FAT_BPB*)BUFFER;
	if((BPB->BS_jmpBoot[0]!=0xeb)&&(BPB->BS_jmpBoot[0]!=0xe9))return SD_FAIL;
	//ȡ
	BPB_BytesPerSec = BPB->BPB_BytesPerSec;
	BPB_SecPerClus = BPB->BPB_SecPerClus;
	BPB_RsvdSecCnt = BPB->BPB_RsvdSecCnt+hidsec; //һFAT
	BPB_NumFATs = BPB->BPB_NumFATs;
	BPB_RootEntCnt = BPB->BPB_RootEntCnt;
	BPB_TotSec16 = BPB->BPB_TotSec16;
	BPB_FATSz16 = BPB->BPB_FATSz16;
	BPB_HiddSec = BPB->BPB_HiddSec;
	FAT_DataStartSec=DataStartSec();
	DirSecCount=GetDirSecCount();
	FAT_DirStartSec=DirStartSec();
	if((BPB->ExecutableMarker[0]==0x55)&&(BPB->ExecutableMarker[1]==0xAA))return SD_SUCC;
	else return SD_FAIL;
}
//-------------------------------------------------------------------------
uint8_t InitFat16(void){							//ʼFAT16ı
	//if(ReadMBR()==SD_FAIL)return SD_FAIL;
	if(ReadBPB()==SD_FAIL)return SD_FAIL;

	return SD_SUCC;
}
//-------------------------------------------------------------------------
void Clear_Clus(uint16_t ClusID){  //һص
unsigned char i;
uint32_t LBA=ClusConvLBA(ClusID);
EmptyBytes(BUFFER,512);
for(i=0;i<BPB_SecPerClus;i++){
	WriteBlock(LBA++);
}
}
//-------------------------------------------------------------------------
uint16_t ReadFAT(uint16_t Index){						//ȡļָ
	uint16_t *RAM=(uint16_t*)BUFFER;
	uint32_t SecID;
	
	SecID=BPB_RsvdSecCnt+Index/256;
	ReadFatBlock(SecID);
	return RAM[Index%256];
}
//-------------------------------------------------------------------------
void WriteFAT(uint16_t Index,uint16_t Value){			//дļָ FAT1
	uint16_t *RAM=(uint16_t*)BUFFER;
	uint32_t SecID;
	
	SecID=BPB_RsvdSecCnt+Index/256; //һFAT
	ReadFatBlock(SecID);
	RAM[Index%256]=Value;
	WriteFatBlock(SecID); //дļָ FAT1
	SecID+=BPB_FATSz16;
	WriteFatBlock(SecID); //дļָ FAT2
}
//-------------------------------------------------------------------------
uint16_t GetEmptyDIR(void){							//ȡĿ¼пʹõһ
	uint16_t i,DirSecCut,DirStart,m,ID=0;
	
	DirSecCut=DirSecCount;
	DirStart=FAT_DirStartSec;
	for(i=0;i<DirSecCut;i++){
		ReadFatBlock(DirStart+i);
		for(m=0;m<16;m++){
			if(BUFFER[m*32]==0)return ID;
			if(BUFFER[m*32]==0xe5)return ID;
			ID++;
		}
	}
	return ID;
}
//-------------------------------------------------------------------------
//úļӦĿ¼
uint8_t GetFileID(uint8_t Name[11],DIR *ID,uint16_t *pIndex){
	uint16_t  i,DirSecCut,DirStart,m;
	
	DirSecCut = DirSecCount;
	DirStart = FAT_DirStartSec;
	for(i=0,*pIndex=0;i<DirSecCut;i++){
		ReadFatBlock(DirStart+i);
		for(m=0;m<16;m++){
			if((BUFFER[m*32]==0)||(BUFFER[m*32]==0xE5)||(BUFFER[m*32+0x0B]==0x0F))continue;
			if(IsEqual(Name,(uint8_t *)&((DIR*)&BUFFER[m*32])->FileName,11)){
				*ID = *((DIR*)&BUFFER[m*32]);
				return 1; 						//ҵӦĿ¼,1.
			}
			(*pIndex)++;
		}
	}
	return 0; 									//ûҵӦĿ¼,0.
}
//-------------------------------------------------------------------------
uint16_t GetNextFAT(void){							//ȡһյFAT
	uint16_t FAT_Count,i,j;
	uint16_t *RAM=(uint16_t*)BUFFER;
	uint16_t FAT_temp=0;
	FAT_Count=BPB_FATSz16*256; 						//FAT
	
	for(i=0;i<BPB_FATSz16;i++){
		ReadFatBlock(BPB_RsvdSecCnt+i);
		for(j=0;j<256;j++){
		if(RAM[j]==0)return FAT_temp;
		FAT_temp++;
		}
	}
	return 0;
}
//-------------------------------------------------------------------------
void ReadDIR(uint16_t Index, DIR* Value){			//ȡĿ¼ָ
	uint32_t LBA = FAT_DirStartSec+Index/16;
	ReadFatBlock(LBA);
	CopyBytes((uint8_t *)&BUFFER[(Index%16)*32],(uint8_t *)Value,32);
}
//-------------------------------------------------------------------------
void WriteDIR(uint16_t Index, DIR* Value){			//дĿ¼ָ
	uint32_t LBA = FAT_DirStartSec+Index/16;
	ReadFatBlock(LBA);
	CopyBytes((uint8_t *)Value,(uint8_t *)&BUFFER[(Index%16)*32],32);
	WriteFatBlock(LBA);
}
//-------------------------------------------------------------------------
void CopyFAT(void){						//ļ,ʹͱһ
	uint16_t i;
	for(i=0;i<BPB_FATSz16;i++){
		ReadFatBlock(BPB_RsvdSecCnt+i);
		WriteFatBlock(BPB_RsvdSecCnt+BPB_FATSz16+i);
	}
}
/*
//-------------------------------------------------------------------------
uint8_t CreateDir(uint8_t *Name){//Ŀ¼´ļ
	uint16_t ClusID, ClusNum, ClusNext,i, dirIndex;
	uint32_t Sec_LBA;
	DIR FileDir;
	DIR *Point; 
	if(GetFileID(Name,&FileDir,&dirIndex)==1)return SD_FAIL;	//ļѴ
	EmptyBytes((uint8_t *)&FileDir,sizeof(DIR));
	CopyBytes(Name,(uint8_t *)&FileDir.FileName,8); //ļûչ
	FileDir.FilePosit.Size=BPB_SecPerClus*BPB_BytesPerSec-1;
	FileDir.FilePosit.Start=GetNextFAT();
	ClusID=FileDir.FilePosit.Start;
	WriteFAT(FileDir.FilePosit.Start,0xffff);//дFATļ־
	
	FileDir.FileAttrib=ATTR_DIRECTORY;  //Ϊļ
	dirIndex=GetEmptyDIR();
	WriteDIR(dirIndex,&FileDir);//ļϢдĿ¼
	
	Sec_LBA=ClusConvLBA(ClusID);
	Clear_Clus(ClusID);
	
	Point=(DIR *)(&BUFFER[0]);
	Point->FileName.NAME[0]=0x2E;
	for(i=1;i<8;i++)Point->FileName.NAME[i]=0x20;
	for(i=0;i<3;i++)Point->FileName.TYPE[i]=0x20;
	Point->UnUsed[0]=LCASE_BASE|LCASE_EXT;
	Point->FileAttrib=ATTR_DIRECTORY;
	Point->FilePosit.Start=ClusID;
	
	Point=(DIR *)(&BUFFER[32]);
	Point->FileName.NAME[0]=0x2E;
	Point->FileName.NAME[1]=0x2E;
	for(i=2;i<8;i++)Point->FileName.NAME[i]=0x20;
	for(i=0;i<3;i++)Point->FileName.TYPE[i]=0x20;
	Point->UnUsed[0]=LCASE_BASE|LCASE_EXT;
	Point->FileAttrib=ATTR_DIRECTORY;
	Point->FilePosit.Start=FAT_DirStartSec;
	WriteBlock(Sec_LBA);
	return SD_SUCC;
}*/
//-------------------------------------------------------------------------
uint8_t CreateFile(uint8_t *Name,uint32_t Size){	//һļ
	uint16_t ClusID, ClusNum, ClusNext, i,dirIndex;
	DIR FileDir;
	
	if(GetFileID(Name,&FileDir,&dirIndex)==1)return SD_FAIL;	//ļѴ
	
	ClusNum=Size/(BPB_SecPerClus*BPB_BytesPerSec)+1;
	Recording_file.num_Clus=ClusNum;
	EmptyBytes((uint8_t *)&FileDir,sizeof(DIR));
	CopyBytes(Name,(uint8_t *)&FileDir.FileName,11);
	FileDir.FilePosit.Size=Size;//ļ
	FileDir.FilePosit.Start=GetNextFAT();//ļʼ
	Recording_file.Frist_Clus=FileDir.FilePosit.Start;//
	ClusID=FileDir.FilePosit.Start;//
	for(i=0;i<ClusNum-1;i++){
		WriteFAT(ClusID,0xffff);
		ClusNext=GetNextFAT();
		WriteFAT(ClusID,ClusNext);
		Clear_Clus(ClusID);
		ClusID=ClusNext;
	}
	Clear_Clus(ClusID);
	WriteFAT(ClusID, 0xffff);//дFATļ־
	Recording_file.DIR_add=GetEmptyDIR();
	WriteDIR(Recording_file.DIR_add,&FileDir);//ļϢдĿ¼
	
	
	Recording_file.Pre_ClusID=ClusID;
	Recording_file.Last_ClusID=ClusID;
	CopyBytes(Name,(uint8_t *)&Recording_file.File.FileName.NAME[0],11);
	Recording_file.position.Size=Size;
	
	return SD_SUCC;
}
//-------------------------------------------------------------------------
uint8_t Add_Clus(void)
{
uint16_t ClusNext;
DIR FileDir;
EmptyBytes((uint8_t *)&FileDir,sizeof(DIR));
CopyBytes((uint8_t *)&Recording_file.File.FileName.NAME[0],(uint8_t *)&FileDir.FileName,11);

Recording_file.position.Size+=BPB_SecPerClus*BPB_BytesPerSec;//ļ

FileDir.FilePosit.Size=Recording_file.position.Size;//ļ
FileDir.FilePosit.Start=Recording_file.Frist_Clus;//ļʼ

Recording_file.num_Clus++;      //ļܴһ
Recording_file.Last_ClusID=Recording_file.Pre_ClusID;

ClusNext=GetNextFAT();
Clear_Clus(ClusNext);
WriteFAT(Recording_file.Pre_ClusID,ClusNext);
WriteFAT(ClusNext, 0xffff);//дFATļ־
Recording_file.Pre_ClusID=ClusNext;  //ļĵǰ

WriteDIR(Recording_file.DIR_add,&FileDir);//ļϢдĿ¼
return SD_SUCC;
}
//-------------------------------------------------------------------------
//ļ
uint8_t ReadFile(uint8_t Name[11],uint32_t Start,uint32_t len,uint8_t *p){
	uint16_t BytePerClus,ClusID,m,dirIndex;
	uint32_t LBA;
	uint8_t	 i;
	DIR      FileDir;
	
	if(GetFileID(Name,&FileDir,&dirIndex)==0)return SD_FAIL;//ļ
	
	BytePerClus=BPB_SecPerClus*BPB_BytesPerSec;		//ÿصֽ
    
	m=Start/BytePerClus;							//㿪ʼλðĴ
	ClusID=FileDir.FilePosit.Start;					//ļĿʼغ
	for(i=0;i<m;i++)ClusID=ReadFAT(ClusID);		//㿪ʼλڴصĴغ	
	i=(Start%BytePerClus)/BPB_BytesPerSec;			//㿪ʼλĴƫ
	LBA=ClusConvLBA(ClusID)+i;						//㿪ʼλõ߼
	m=(Start%BytePerClus)%BPB_BytesPerSec;			//㿪ʼλƫ

READ:
	for(;i<BPB_SecPerClus;i++){
		ReadFatBlock(LBA++);
		for(;m<BPB_BytesPerSec;m++){
			*p++=BUFFER[m];
			if(--len==0)return SD_SUCC;			//ȡɾ˳
		}
		m=0;
	}
	i=0;
	ClusID=ReadFAT(ClusID);							//һشغ
	LBA=ClusConvLBA(ClusID);
	goto READ;
}
//-------------------------------------------------------------------------
unsigned char get_file(uint8_t Name[11]){
uint16_t dirIndex;
DIR      FileDir;
if(GetFileID(Name,&FileDir,&dirIndex)==0)return SD_FAIL;//ļ
Reading_file.position.Start=FileDir.FilePosit.Start;
Reading_file.position.Size=FileDir.FilePosit.Size;
Reading_file.Pre_ClusID=FileDir.FilePosit.Start;
return SD_SUCC;
}
//-------------------------------------------------------------------------
unsigned char Get_Next_Wav(unsigned int wav_num){
	uint16_t  i,m,wav_count=0;
	DIR      FileDir;
	
	for(i=0;i<DirSecCount;i++){ //ϴĿ¼ʼ
		ReadFatBlock(FAT_DirStartSec+i);
		for(m=0;m<16;m++){

			if((BUFFER[m*32]==0)||(BUFFER[m*32]==0xE5)||(BUFFER[m*32+0x0B]==0x0F))continue; // ļЧ 
			if((BUFFER[m*32+8]=='W')&&(BUFFER[m*32+9]=='A')&&(BUFFER[m*32+10]=='V')){ //һWAVļ
				
			if(wav_count++==wav_num){
				FileDir = *((DIR*)&BUFFER[m*32]);  //õļĿ¼Ϣ
				Reading_file.position.Start=FileDir.FilePosit.Start;
				Reading_file.position.Size=FileDir.FilePosit.Size;
				Reading_file.File.FileName=FileDir.FileName;
				Reading_file.Pre_ClusID=FileDir.FilePosit.Start;  //õļʼ 
				return 1; 		//ҵӦĿ¼,1.
				}
			}
			
		}
		
	}
	return 0; 									//ûҵӦĿ¼,0.

}
//-------------------------------------------------------------------------
unsigned int How_Many_Wav(void){
	uint16_t  i,m,wav_count=0;
	for(i=0;i<DirSecCount;i++){ 
		ReadFatBlock(FAT_DirStartSec+i);
		for(m=0;m<16;m++){
			if((BUFFER[m*32]==0)||(BUFFER[m*32]==0xE5)||(BUFFER[m*32+0x0B]==0x0F))continue; // ļЧ 
			if((BUFFER[m*32+8]=='W')&&(BUFFER[m*32+9]=='A')&&(BUFFER[m*32+10]=='V')){ //һWAVļ
				wav_count++;
			}
		}
	}
	return wav_count; 									//ûҵӦĿ¼,0.
}
//-------------------------------------------------------------------------
//һеһ
void FAT16_LoadPartCluster(unsigned int cluster,unsigned part)
{
	uint32_t sector;
	sector=FAT_DataStartSec+(uint32_t)BPB_SecPerClus*(uint32_t)(cluster-2);//calculate the actual sector number
	ReadFatBlock(sector+part); //read the block store in the buffer
}
//-------------------------------------------------------------------------
//дļ
uint8_t WriteFile(uint8_t Name[11],uint32_t Start,uint32_t len,uint8_t *p){
	uint16_t BytePerClus,ClusID,m,dirIndex;
	uint32_t LBA;
	uint8_t	 i;
	DIR      FileDir;
	
	if(GetFileID(Name,&FileDir,&dirIndex)==0)return SD_FAIL;//ļ
	
	BytePerClus=BPB_SecPerClus*BPB_BytesPerSec;		// ÿصֽ	
	m=Start/BytePerClus;							//㿪ʼλðĴ
	ClusID=FileDir.FilePosit.Start;					//ļĿʼغ
	for(i=0;i<m;i++)ClusID=ReadFAT(ClusID);		//㿪ʼλڴصĴغ	
	i=(Start%BytePerClus)/BPB_BytesPerSec;			//㿪ʼλĴƫ
	LBA=ClusConvLBA(ClusID)+i;						//㿪ʼλõ߼
	m=(Start%BytePerClus)%BPB_BytesPerSec;			//㿪ʼλƫ

WRITE:
	for(;i<BPB_SecPerClus;i++){
		ReadFatBlock(LBA);
		for(;m<BPB_BytesPerSec;m++){
			BUFFER[m]=*p++;
			if(--len==0){							//ȡɾ˳
				WriteFatBlock(LBA);					//д
				return SD_SUCC;				
			}
		}
		m=0;
		WriteFatBlock(LBA++);						//д
	}
	i=0;
	ClusID=ReadFAT(ClusID);							//һشغ
	LBA=ClusConvLBA(ClusID);
	goto WRITE;
}
//-------------------------------------------------------------------------
//дļ
//дָļlenܴһأ
uint8_t MY_WriteFile(uint8_t Name[11],uint32_t Start,uint32_t len,uint8_t *p,File_prop *file_dis){
	uint16_t BytePerClus,ClusID,m;
	uint32_t LBA;
	uint8_t	 i;

	
	BytePerClus=BPB_SecPerClus*BPB_BytesPerSec;		// ÿصֽ	
	
	if((file_dis->position.Size-BytePerClus)>=Start)ClusID=file_dis->Last_ClusID;
		else ClusID=file_dis->Pre_ClusID;//ļĿʼغ
	
	i=(Start%BytePerClus)/BPB_BytesPerSec;			//㿪ʼλĴƫ
	LBA=ClusConvLBA(ClusID)+i;						//㿪ʼλõ߼
	m=(Start%BytePerClus)%BPB_BytesPerSec;			//㿪ʼλƫ

MYWRITE:
	for(;i<BPB_SecPerClus;i++){
		ReadFatBlock(LBA);
		for(;m<BPB_BytesPerSec;m++){
			BUFFER[m]=*p++;
			if(--len==0){							//ȡɾ˳
				WriteFatBlock(LBA);					//д
				return SD_SUCC;				
			}
		}
		m=0;
		WriteFatBlock(LBA++);						//д
	}
	i=0;
	ClusID=file_dis->Pre_ClusID;							//һشغ
	LBA=ClusConvLBA(ClusID);
	goto MYWRITE;
}

//-------------------------------------------------------------------------
//ɾļ
uint8_t EreaseFile(uint8_t Name[11]){
	uint16_t ClusID,ClusNext,dirIndex;
	DIR FileDir;
	
	if(GetFileID(Name,&FileDir,&dirIndex)==0)return SD_FAIL;	//ļ
	ClusID=FileDir.FilePosit.Start;					//ļĿʼغ

EREASEFAT:
	if((ClusNext=ReadFAT(ClusID))!=0xffff){		//ɾFATе
		WriteFAT(ClusID,0x0000);
		ClusID=ClusNext;
	}else{
		WriteFAT(ClusID,0x0000);
		goto EREASEFATEND;
	}
	goto EREASEFAT;
EREASEFATEND:
	
	FileDir.FileName.NAME[0]=0xe5;					//ɾDirеļ¼
	WriteDIR(dirIndex,&FileDir);
	CopyFAT();										//FAT2<-FAT1
	return SD_SUCC;
}
//-------------------------------------------------------------------------
