//-------------------------------------------------------------------------
typedef struct{
	uint8_t		PB_BootIndicator;
	uint8_t		PB_StartHead;
	uint16_t	PB_StartSector;
	uint8_t		PB_SystemID;
	uint8_t		PB_EndHead;
	uint16_t	PB_EndSector;
	uint32_t	PB_RelativeSector;
	uint32_t	PB_TotalSector;		
} FAT_PB;
//-------------------------------------------------------------------------
typedef struct{
	uint8_t		MBR_mbr[446];
	FAT_PB		MBR_pb[4];
	uint16_t	MBR_Signature;
} FAT_MBR;
//-------------------------------------------------------------------------
typedef struct{
	uint8_t		BS_jmpBoot[3];
	uint8_t		BS_OEMName[8];
	uint16_t	BPB_BytesPerSec;
	uint8_t		BPB_SecPerClus;
	uint16_t	BPB_RsvdSecCnt;
	uint8_t		BPB_NumFATs;
	uint16_t	BPB_RootEntCnt;
	uint16_t	BPB_TotSec16;
	uint8_t		BPB_Media;
	uint16_t	BPB_FATSz16;
	uint16_t	BPB_SecPerTrk;
	uint16_t	BPB_NumHeads;
	uint32_t	BPB_HiddSec;
	uint32_t	BPB_TotSec32;
	uint8_t		BS_DrvNum;
	uint8_t		BS_Reservedl;
	uint8_t		BS_BootSig;
	uint32_t	BS_VolID;
	uint8_t		BS_VolLab[11];
	uint8_t		BS_FilSysType[8];
	uint8_t		ExecutableCode[448];
	uint8_t		ExecutableMarker[2];
} FAT_BPB;
//-------------------------------------------------------------------------
typedef struct{
	uint8_t		NAME[8];
	uint8_t		TYPE[3];
} FILE_NAME;
//-------------------------------------------------------------------------
typedef struct{ 
	uint16_t	Start;
	uint32_t	Size;
} FILE_POSIT;
//-------------------------------------------------------------------------
typedef struct{
	FILE_NAME	FileName;
	uint8_t		FileAttrib;
	#define ATTR_NORMAL     0x00            // normal file
	#define ATTR_READONLY   0x01            // file is readonly
	#define ATTR_HIDDEN     0x02            // file is hidden
	#define ATTR_SYSTEM     0x04            // file is a system file
	#define ATTR_VOLUME     0x08            // entry is a volume label
	#define ATTR_LONG_FILENAME	0x0F		// this is a long filename entry			    
	#define ATTR_DIRECTORY  0x10            // entry is a directory name
	#define ATTR_ARCHIVE    0x20            // file is new or modified
	uint8_t		UnUsed[10];
	#define LCASE_BASE      0x08            // filename base in lower case
	#define LCASE_EXT       0x10            // filename extension in lower case
	uint8_t		FileUpdateTime[2];
	uint8_t		FileUpdateData[2];
	FILE_POSIT	FilePosit;
} DIR;
//-------------------------------------------------------------------------
typedef struct{
	uint16_t	ClusID;
	uint16_t	SecOfClus;
	uint16_t	ByteOfSec;
} DATA_POSIT;
typedef struct{
	DIR File;
	FILE_POSIT position;
	uint16_t   Frist_Clus;
	uint16_t   Last_ClusID;
	uint16_t   Pre_ClusID;
	uint16_t   DIR_add;
	uint16_t   num_Clus;
} File_prop;
//-------------------------------------------------------------------------
#define	SD_SUCC				0
#define	SD_FAIL				1
//-------------------------------------------------------------------------
extern uint8_t		PB_RelativeSector;
extern uint16_t	    BPB_BytesPerSec;
extern uint16_t		BPB_SecPerClus;
extern uint16_t	    BPB_RsvdSecCnt;
extern uint8_t		BPB_NumFATs;
extern uint16_t	    BPB_RootEntCnt;
extern uint16_t	    BPB_TotSec16;
extern uint16_t	    BPB_FATSz16;							//FATռõsectors
extern uint32_t	    BPB_HiddSec;
extern File_prop    Recording_file;
extern uint8_t		BUFFER[512];
//-------------------------------------------------------------------------
uint8_t InitFat16(void);
uint16_t ReadFAT(uint16_t Index);
uint8_t CreateFile(uint8_t* Name,uint32_t Size);
uint8_t EreaseFile(uint8_t Name[11]);
uint8_t ReadFile(uint8_t Name[11],uint32_t Start,uint32_t len,uint8_t *p);
uint8_t WriteFile(uint8_t Name[11],uint32_t Start,uint32_t len,uint8_t *p);
uint8_t Add_Clus(void);
uint8_t MY_WriteFile(uint8_t Name[11],uint32_t Start,uint32_t len,uint8_t *p,File_prop *file_dis);
unsigned char get_file(uint8_t Name[11]);
void FAT16_LoadPartCluster(unsigned int cluster,unsigned part);
unsigned char Get_Next_Wav(unsigned int wav_num);
unsigned int How_Many_Wav(void);
//-------------------------------------------------------------------------
