#include "dac_driver.h"
#include "clksys_driver.h"
#include "TC_driver.h"
#include "dma_driver.h"
#include "usart.h"
#include "FAT16.h"
#include "mmc.h"
#include "LED.h"
#include "LCD.h"
#include "KEY.h"

#define TCC0_CLK  320000UL //Khz



#define _16Bit_Stero  1
#define _16Bit_Mono   2
#define _8Bit_Stero   3
#define _8Bit_Mono    4
#define DAC_STOP      5

#define ADJ_Vaule     100

#define MSG    "XMEGA WAVE PLAYER!!"
#define NOCARD "NO CARD!!"
#define OKCARD "CARD & FAT16 initial!!"


extern File_prop  Reading_file;

unsigned char ADC_test=0;

//--WAV-------------------------------------------
volatile unsigned char Wave[512],H_empty,A_empty,Open_flag=0;
volatile unsigned char Track_Num=1,Data_bits,Sound_Mode,Ready_flag;
volatile unsigned long Play_size,Data_Size,Play_Percent;
volatile unsigned int Sample_Rate,Play_Time;
volatile unsigned int W_index=0;

//--DMA-------------------------------------------

/*! block memory copy.
 *
 *  Block size 0 = 64k. Enable the DMA channel to use first and it will be
 *  disabled automatically. Setup channel for copying data, increasing
 *  addresses, no address pointer reload, with 8-byte bursts.
 */
bool BlockMemCopy( const void * src,
                   void * dest,
                   uint16_t blockSize,
                   volatile DMA_CH_t * dmaChannel )
{
	DMA_EnableChannel( dmaChannel );

	DMA_SetupBlock( dmaChannel,
	                src,
	                DMA_CH_SRCRELOAD_NONE_gc,
	                DMA_CH_SRCDIR_INC_gc,
	                dest,
	                DMA_CH_DESTRELOAD_NONE_gc,
	                DMA_CH_DESTDIR_INC_gc,
	                blockSize,
	                DMA_CH_BURSTLEN_8BYTE_gc,
	                0,
	                false );

	DMA_StartTransfer( dmaChannel );

	return true;
}

//ϵͳʱ 32M
//----------------------------------------------------------------------------
void sysclk_initial(void)
{
		/*  Enable internal 32 MHz ring oscillator and wait until it's
		 *  stable. Divide clock by two with the prescaler C and set the 16M
		 *  32 MHz ring oscillator as the main clock source. 
		 */
		CLKSYS_Enable( OSC_RC32MEN_bm );
		CLKSYS_Prescalers_Config( CLK_PSADIV_1_gc, CLK_PSBCDIV_1_1_gc );
		do {} while ( CLKSYS_IsReady( OSC_RC32MRDY_bm ) == 0 );
		CLKSYS_Main_ClockSource_Select( CLK_SCLKSEL_RC32M_gc );
}
//----------------------------------------------------------------------------
void Timer_initial(void)
{
	/* Set period/TOP value.    */
	TC_SetPeriod( &TCC0,362);
	
	/* Enable overflow interrupt at low level */
	TC0_SetOverflowIntLevel( &TCC0, TC_OVFINTLVL_LO_gc );
	PMIC.CTRL |= PMIC_LOLVLEN_bm;

	sei();
	
	/* Select clock source. 2 Ƶ  16M*/
	TC0_ConfigClockSource( &TCC0, TC_CLKSEL_DIV1_gc);

//Time1 for key
	/* Set period/TOP value.    */
	TC_SetPeriod( &TCC1,625);
	
	/* Enable overflow interrupt at low level */
	TC1_SetOverflowIntLevel( &TCC1, TC_OVFINTLVL_LO_gc );
	PMIC.CTRL |= PMIC_LOLVLEN_bm;

	sei();
	
	/* Select clock source. 1024 Ƶ  32M/1024= 31.25k*/
	TC1_ConfigClockSource( &TCC1, TC_CLKSEL_DIV1024_gc);
}
//----------------------------------------------------------------------------
void SD_initial(void)
{
	unsigned int i;
	mmcInit();
	do{
	}
	while(mmcReset()!=0);
	LED2_ON();
	MMC_get_volume_info();
	if(InitFat16()==SD_SUCC){
							putstr((void*)OKCARD);
							}
							else {putstr((void*)NOCARD);while(1);}//޿ ֹͣ
	sei(); 				//re-enable interrupts
	for(i=0;i<512;i++)Wave[i]=0;
}
//----------------------------------------------------------------------------
/*
    |       |ռֽ|    | 
    ================================== 
    | ID    | 4 Bytes |   'RIFF'    | 
    ---------------------------------- 
    | Size  | 4 Bytes |             | 
    ---------------------------------- 
    | Type  | 4 Bytes |   'WAVE'    | 
    ---------------------------------- 
    ==================================================================== 
    |               |  ֽ |                              | 
    ==================================================================== 
    | ID            | 4 Bytes |   'fmt '                             | 
    -------------------------------------------------------------------- 
    | Size          | 4 Bytes | ֵΪ161818ָϢ     | 
    -------------------------------------------------------------------- ---- 
    | FormatTag     | 2 Bytes | 뷽ʽһΪ0x0001               |     | 
    --------------------------------------------------------------------     | 
    | Channels      | 2 Bytes | Ŀ1--2--˫       |     | 
    --------------------------------------------------------------------     | 
    | SamplesPerSec | 4 Bytes | Ƶ                             |     | 
    --------------------------------------------------------------------     | 
    | AvgBytesPerSec| 4 Bytes | ÿֽ                       |     |===> WAVE_FORMAT 
    --------------------------------------------------------------------     | 
    | BlockAlign    | 2 Bytes | ݿ뵥λ(ÿҪֽ) |     | 
    --------------------------------------------------------------------     | 
    | BitsPerSample | 2 Bytes | ÿҪbit                  |     | 
    --------------------------------------------------------------------     | 
    |               | 2 Bytes | ϢѡͨSizeжޣ |     | 
    -------------------------------------------------------------------- ---- 
*/
unsigned char load_head(void)
{
	unsigned int i;

	//һ 512ֽ WAV ļĵһ
	FAT16_LoadPartCluster(Reading_file.Pre_ClusID,0);
	
	if((BUFFER[0]=='R')&&(BUFFER[1]=='I')&&(BUFFER[2]=='F')&&(BUFFER[3]=='F'))
	{
	Track_Num=BUFFER[0x16];  //
	Sample_Rate=(unsigned int)BUFFER[0x19]*256+BUFFER[0x18];//
	Data_bits=BUFFER[0x22];  //λ
	Data_Size=((unsigned long)BUFFER[0x2b]<<24)|((unsigned long)BUFFER[0x2a]<<16)|((unsigned long)BUFFER[0x29]<<8)|(unsigned long)BUFFER[0x28];
	Play_size=0;
	if((Track_Num==2)&&(Data_bits==16)){
										Sound_Mode=_16Bit_Stero;
										display_list_char(10,3,(void*)"_16Bit_Stero");
										}
										
	if((Track_Num==1)&&(Data_bits==16)){
										Sound_Mode=_16Bit_Mono;
										display_list_char(10,3,(void*)"_16Bit_Mono");
										}
										
	if((Track_Num==2)&&(Data_bits==8)){
										Sound_Mode=_8Bit_Stero;
										display_list_char(10,3,(void*)"_8Bit_Stero");
										}
										
	if((Track_Num==1)&&(Data_bits==8)){
										Sound_Mode=_8Bit_Mono;
										display_list_char(10,3,(void*)"_8Bit_Mono");
										}
										
	display_number(2,3,(unsigned int)(Sample_Rate/1000));
	display_list_char(2+4,3,(void*)"KHz");
	
	Sample_Rate=Sample_Rate/100;
	i=TCC0_CLK/Sample_Rate;

	TC_SetPeriod(&TCC0,i);  //Set DAC rate

	return 1;
	}
	else {display_list_char(10,3,(void*)"ERRO!!     ");return 0;}
}
//----------------------------------------------------------------------------
void wav_play(void)
{
	uint8_t i=1,percent,temp=0,song_num=0;
	uint16_t count;
	
	count=How_Many_Wav(); //Ŀ¼WAVļ
	display_number(8,4,count);
	
	while(Get_Next_Wav(song_num)==0); //Ŀ¼ûWAVļ
	Open_flag=0;//λļǵһδ򿪣ʾҪ load_head();
	song_num++;
	display_number(2,4,(unsigned int)song_num);
	while(1){
	
	if(Open_flag==0){ //һδWAVļ
	load_head();
	Open_flag=1;
	i=1;
	}
	
	for(;i<BPB_SecPerClus;i++){
	
	//һ 512ֽ
	FAT16_LoadPartCluster(Reading_file.Pre_ClusID,i);
	
	
	while(H_empty==0);  //DAC һ룿
	BlockMemCopy( BUFFER,
		          Wave,
		          256,
		          &DMA.CH0); //  256 ֽڵDAC 
	H_empty=0;
	while(A_empty==0); //DAC 
	BlockMemCopy( &BUFFER[256],
		          &Wave[256],
		          256,
		          &DMA.CH0);
	A_empty=0;
	Play_size+=512;
	}
	
	Play_Percent=(Play_size*100)/Data_Size;
	percent=(unsigned char)Play_Percent;
	
	
	display_bar(128-100,7,percent);
	
	if(Key_Return)
	{
	switch(Key_Return){
	case RSELECT:     display_list_char(0,6,(void*)"  RSELECT   ");break;
	case RLEFT:       display_list_char(0,6,(void*)"  RLEFT     ");break;
	case RRIGHT:      display_list_char(0,6,(void*)"  RRIGHT    ");break;
	case RUP:         display_list_char(0,6,(void*)"  RUP       ");break;
	case RDOWN:       display_list_char(0,6,(void*)"  RDOWN     ");break;
	case RLong_SELECT:display_list_char(0,6,(void*)"RLong_SELECT");break;
	case RLong_LEFT:  display_list_char(0,6,(void*)"RLong_SELECT");break;
	case RLong_RIGHT: display_list_char(0,6,(void*)"RLong_SELECT");break;
	case RLong_UP:    display_list_char(0,6,(void*)"RLong_SELECT");break;
	case RLong_DOWN:  display_list_char(0,6,(void*)"RLong_SELECT");break;
	default :         display_list_char(0,6,(void*)"No Ideti    ");break;
	}
	//Key_Return=0;
	}
	
	i=0;LED1_T();
	//һ
	Reading_file.Pre_ClusID=ReadFAT(Reading_file.Pre_ClusID);
	//ļ
	if(Key_Return){
	if(Key_Return==RSELECT){
			Open_flag=0;   //λļǵһδ򿪣ʾҪ load_head();
			Sound_Mode=DAC_STOP;//No ready To DAC
			if(Get_Next_Wav(song_num)==0){
			song_num=0;
			Get_Next_Wav(song_num);
			}
			temp=0;
			for(count=0;count<512;count++)Wave[count]=0;
			song_num++;
			display_number(2,4,(unsigned int)song_num);
	}
	Key_Return=0;
	}

	if(Reading_file.Pre_ClusID==0xffff || Reading_file.Pre_ClusID==0xfff8){
										Open_flag=0;   //λļǵһδ򿪣ʾҪ load_head();
										Sound_Mode=DAC_STOP;//No ready To DAC
										if(Get_Next_Wav(song_num)==0){
										song_num=0;
										Get_Next_Wav(song_num);
										}
										temp=0;
										for(count=0;count<512;count++)Wave[count]=0;
										song_num++;
										display_number(2,4,(unsigned int)song_num);
										}
	}
}
//----------------------------------------------------------------------------
int main( void )
{
	sysclk_initial(); //32MHZ
	KEY_initial();
	LED_initial();
	USART_initial();
	DAC_DualChannel_Enable( &DACB,
	                        DAC_REFSEL_AVCC_gc,
	                        false,
	                        DAC_CONINTVAL_128CLK_gc,
	                        DAC_REFRESH_32CLK_gc );
	BELL_OFF();
	SD_initial();
	//RTCinit();
	putstr((void*)MSG);
	
	LCD_initial();
	LCD_clear();
	display_list_char(2,0,(void*)"XMEGA WAV PLAYER");
	display_list_char(0,1,(void*)"SD_Name:");
	display_list_char(9,1,vinf.name);
	display_list_char(0,2,(void*)"SD_Size:");
	display_number(9,2,(unsigned int)vinf.size_MB);
	display_list_char(9+4,2,(void*)"MB");
	display_list_char(9+7,2,(void*)"FAT16");
	
	display_list_char(0,7,(void*)"PLAY");
	
	DMA_Enable();
    Timer_initial();
	Sound_Mode=DAC_STOP;
	
	BELL_OFF();
	
	while(1)wav_play(); //wav play rutine

}

//----------------------------------------------------------------------------
/*
    --------------------------------------------------------------------- 
    |     |    ȡ1    |    ȡ2    |    ȡ3    |    ȡ4    | 
    |           |-------------------------------------------------------- 
    | 8bit  |    0    |    0    |    0    |    0    | 
    --------------------------------------------------------------------- 
    |   ˫  |          ȡ1            |           ȡ2           | 
    |           |-------------------------------------------------------- 
    | 8bit  |  0()  |  1()  |  0()  |  1()  | 
    --------------------------------------------------------------------- 
    |           |          ȡ1            |           ȡ2           | 
    |     |-------------------------------------------------------- 
    | 16bit |    0    |  0      |    0    | 0       | 
    |           | (λֽ)  |  (λֽ) | (λֽ)  | (λֽ)  | 
    --------------------------------------------------------------------- 
    |           |                         ȡ1                         | 
    |   ˫  |-------------------------------------------------------- 
    | 16bit |  0()  |  0()  |  1()  | 1()   | 
    |           |  (λֽ) |  (λֽ) |  (λֽ) | (λֽ)  | 
    --------------------------------------------------------------------- 
*/
ISR(TCC0_OVF_vect)
{
//if(Ready_flag==0)return;
//unsigned int temp;	

switch(Sound_Mode){
case _8Bit_Mono:

	DACB.CH0DATA=Wave[W_index]+ADJ_Vaule;
	
	DACB.CH1DATA=Wave[W_index]+ADJ_Vaule;
	
	W_index++;
break;

case _8Bit_Stero:

	DACB.CH0DATA=Wave[W_index]+ADJ_Vaule;
	W_index++;

	DACB.CH1DATA=Wave[W_index]+ADJ_Vaule;
	W_index++;
break;

case _16Bit_Mono:


	DACB.CH0DATA=Wave[W_index+1]+ADJ_Vaule;

	DACB.CH1DATA=Wave[W_index+1]+ADJ_Vaule;
	W_index++;W_index++;
break;

case _16Bit_Stero:


	DACB.CH0DATA=Wave[W_index+1]+ADJ_Vaule;
	W_index++;W_index++;


	DACB.CH1DATA=Wave[W_index+1]+ADJ_Vaule;
	W_index++;W_index++;
break;

case DAC_STOP: 
	W_index=0;
	break;

default:break;
}

if(W_index==256)H_empty=1;
	else if(W_index==512){A_empty=1;W_index=0;}
}

//----------------------------------------------------------------------------
ISR(TCC1_OVF_vect)
{
	system_tick++;
	unsigned char Temp;
	Temp=Get_Key();

	//------------------------
	if(Temp==SELECT){
					Key_Time_SELECT++;
					if(Key_Time_SELECT>Long_Key_16ms){Key_Time_SELECT=Long_Sure;Key_Return=RLong_SELECT;}
					Key_Time_LEFT=0;
					Key_Time_RIGHT=0;
					Key_Time_DOWN=0;
					Key_Time_UP=0;
					}
	else if(Temp==LEFT){
					Key_Time_LEFT++;
					if(Key_Time_LEFT>Long_Key_16ms){Key_Time_LEFT=Long_Sure;Key_Return=RLong_LEFT;}
					Key_Time_SELECT=0;
					Key_Time_RIGHT=0;
					Key_Time_DOWN=0;
					Key_Time_UP=0;	
				    }
	else if(Temp==RIGHT)
					{
					Key_Time_RIGHT++;
					if(Key_Time_RIGHT>Long_Key_16ms){Key_Time_RIGHT=Long_Sure;Key_Return=RLong_RIGHT;}
					Key_Time_SELECT=0;
					Key_Time_LEFT=0;
					Key_Time_DOWN=0;
					Key_Time_UP=0;
					}
	else if(Temp==UP)
					{
					Key_Time_UP++;
					if(Key_Time_UP>Long_Key_16ms){Key_Time_UP=Long_Sure;Key_Return=RLong_UP;}
					Key_Time_SELECT=0;
					Key_Time_LEFT=0;
					Key_Time_RIGHT=0;
					Key_Time_DOWN=0;
					}
	else if(Temp==DOWN)
					{
					Key_Time_DOWN++;
					if(Key_Time_DOWN>Long_Key_16ms){Key_Time_DOWN=Long_Sure;Key_Return=RLong_DOWN;}
					Key_Time_SELECT=0;
					Key_Time_LEFT=0;
					Key_Time_RIGHT=0;
					Key_Time_UP=0;
					}
	else{
		if((Key_Time_SELECT>Short_Key_16ms)&&(Key_Time_SELECT<Long_Sure-1)){Key_Return=RSELECT;}
		else if((Key_Time_LEFT>Short_Key_16ms)&&(Key_Time_LEFT<Long_Sure-1)){Key_Return=RLEFT;}
		else if((Key_Time_RIGHT>Short_Key_16ms)&&(Key_Time_RIGHT<Long_Sure-1)){Key_Return=RRIGHT;}
		else if((Key_Time_UP>Short_Key_16ms)&&(Key_Time_UP<Long_Sure-1)){Key_Return=RUP;}
		else if((Key_Time_DOWN>Short_Key_16ms)&&(Key_Time_DOWN<Long_Sure-1)){Key_Return=RDOWN;}
		else ;
		Key_Time_SELECT=0;
		Key_Time_LEFT=0;
		Key_Time_RIGHT=0;
		Key_Time_UP=0;
		Key_Time_DOWN=0;
		}
}
//----------------------------------------------------------------------------
//end of file