#include <avr/eeprom.h>
#include "avr_compiler.h"
#include "eeprom_driver.h"
#include "M16_OLED_Driver.h"
#include "DS1302.h"
#include "KEY.h"
#include "SOUND.h"
#define WDR() 	asm("wdr")


unsigned int contrast   =  (unsigned int)0;
unsigned int P_on_hour  =  (unsigned int)1;
unsigned int P_on_min   =  (unsigned int)2;
unsigned int P_off_hour =  (unsigned int)3;
unsigned int P_off_min  =  (unsigned int)4;

unsigned int alarm1_hour = (unsigned int)5;
unsigned int alarm1_min  = (unsigned int)6;
unsigned int alarm2_hour = (unsigned int)7;
unsigned int alarm2_min  = (unsigned int)8;

unsigned int alarm1_mode = (unsigned int)9;
unsigned int alarm2_mode = (unsigned int)10;

unsigned char Display_S=1,flash,Disp=0,Updata=1;
unsigned char Display_Flag=0;
unsigned char a1_HOUR,a1_MIN,a2_HOUR,a2_MIN,po_HOUR,po_MIN,pf_HOUR,pf_MIN;
unsigned char Alarm_set_mode1=0,Alarm_set_mode2;

void System_confi(void);
void Set_Time(void);
void configation(void);
void display_mode(unsigned char mode);


void delay_(void)
{
unsigned int i=65530;
while(i--);

}
//  interrput for evry 250ms
/*
+------------------------------------------------------------------------------
| Function    : Initial_Timer
+------------------------------------------------------------------------------
| Description : initial the Timer 
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
void Initial_Timer(void)
{
TCC1.PER=976*4;  //250ms (16M/1024/4)
TCC1.INTCTRLA=TC_OVFINTLVL_LO_gc;//Enable Timer Overflow interrupt
/* Select clock source. 1024Div 16M/1024*/
TCC1.CTRLA=TC_CLKSEL_DIV1024_gc;

}

/*
+------------------------------------------------------------------------------
| Function    : OSC_8M_PLL_SystemsClk
+------------------------------------------------------------------------------
| Description : ext OSC 8M use PLL  
|  				16M CLK
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
void OSC_8M_PLL_SystemsClk(void)
{

OSC.CTRL &=~OSC_RC32MEN_bm; //Disable RC32M
//Setting Ext. OSC//XTAL_16KCLK 0.4 - 16 MHz XTAL 16K CLK
OSC.XOSCCTRL=OSC_FRQRANGE_2TO9_gc | OSC_X32KLPM_bm | OSC_XOSCSEL_XTAL_16KCLK_gc;
/* Turn on Ext. 8M & 32kHz. */
OSC.CTRL |=OSC_XOSCEN_bm;
	do {
		/* Wait for the oscillators to stabilize. */
	} while ( ( OSC.STATUS & OSC_XOSCRDY_bm ) == 0);

OSC.PLLCTRL= (uint8_t)OSC_PLLSRC_XOSC_gc | 0x2; //8M* 4=16M 
OSC.CTRL|=OSC_PLLEN_bm;  //Enable PLL
CLK.PSCTRL= (uint8_t)CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;//prescaler configuration
while((OSC.STATUS & OSC_PLLRDY_bm)==0); //Wait PLL Ready
CCP = CCP_IOREG_gc;
CLK.CTRL = CLK_SCLKSEL_PLL_gc;   //Use PLL as Main Clock

}


/////////////////////////////////////
void initial_Alarm(void)
{
//read alarm group 1
unsigned char temp;
	/* Flush buffer just to be sure when we start.*/
EEPROM_FlushBuffer();
EEPROM_DisableMapping();

 
temp=EEPROM_ReadByte_(alarm1_hour);//
a1_HOUR=(temp/10)<<4;
a1_HOUR|=temp%10;
 
temp=EEPROM_ReadByte_(alarm1_min);
a1_MIN=(temp/10)<<4;
a1_MIN|=temp%10;
 
//read alarm group 2
temp=EEPROM_ReadByte_(alarm2_hour);
a2_HOUR=(temp/10)<<4;
a2_HOUR|=temp%10;
 
temp=EEPROM_ReadByte_(alarm2_min);
a2_MIN=(temp/10)<<4;
a2_MIN|=temp%10;
///////////////////////////////////////
///read auto power on time
 
temp=EEPROM_ReadByte_(P_on_hour);
po_HOUR=(temp/10)<<4;
po_HOUR|=temp%10;
 
temp=EEPROM_ReadByte_(P_on_min);
po_MIN=(temp/10)<<4;
po_MIN|=temp%10;
 
///read auto power off time
temp=EEPROM_ReadByte_(P_off_hour);
pf_HOUR=(temp/10)<<4;
pf_HOUR|=temp%10;
 
temp=EEPROM_ReadByte_(P_off_min);
pf_MIN=(temp/10)<<4;
pf_MIN|=temp%10;
//////////////////////////////
///read alarm mode  
// 0 for evryday
// 1 for week 1-5
// 2 for week 1-6
// 3 for alarm off
 
Alarm_set_mode1=EEPROM_ReadByte_(alarm1_mode);
if(Alarm_set_mode1>4)Alarm_set_mode1=0;
 
Alarm_set_mode2=EEPROM_ReadByte_(alarm2_mode);
if(Alarm_set_mode2>4)Alarm_set_mode2=0;
}


void check_alarm(void)
{
///alarm group 1
if((a1_HOUR==Time[2])&&(a1_MIN==Time[1])){
if(Alarm_set_mode1==0) //alarm evryday
				{if(Time[0]<10)SOUND_RING1();}
else if((Alarm_set_mode1==1)&&(Time[5]!=6)&&(Time[5]!=7))
		{if(Time[0]<10)SOUND_RING1();}
else if((Alarm_set_mode1==2)&&(Time[5]!=7))
		{if(Time[0]<10)SOUND_RING1();}
else ;
}
///alarm group 2
if((a2_HOUR==Time[2])&&(a2_MIN==Time[1])){
if(Alarm_set_mode2==0) //alarm evryday
				{if(Time[0]<10)SOUND_RING1();}
else if((Alarm_set_mode2==1)&&(Time[5]!=6)&&(Time[5]!=7)) //week 1-5
		{if(Time[0]<10)SOUND_RING1();}
else if((Alarm_set_mode2==2)&&(Time[5]!=7))   //week 1-6
		{if(Time[0]<10)SOUND_RING1();}
else ;
}
////auto power off 
if((pf_HOUR==Time[2])&&(pf_MIN==Time[1])&&(Time[0]==0)){
displayoff();
SOUND_ENTER();
Display_Flag|=0x01;
}
 ///auto power on
if((po_HOUR==Time[2])&&(po_MIN==Time[1])&&(Time[0]==0)){
displayon();
SOUND_ENTER();
Display_Flag&=~0x01;
}

// ʱ
if((Time[1]==0)&&(Time[0]==0)&&(Display_Flag==0x00)){
SOUND_RING2();
}
if((Time[1]==0x30)&&(Time[0]==0)&&(Display_Flag==0x00)){
SOUND_RING3();
}


}
/////////////////////////////////////
int main(void)
{
unsigned char Temp;
OSC_8M_PLL_SystemsClk();
OLED_initial();
initial_LED_KEY();
ini_oled();
ini_dis();
SOUNDINIT_timer2_init();
Initial_RTC();
///set the lcd contrast
Temp=EEPROM_ReadByte_(contrast);
//Set_Contrast(Temp);
initial_Alarm();
Initial_Timer();
SOUND_ADD();

sei();
Display_Flag=0;
displayon();
while(1){

System_confi(); //check the key return
check_alarm();  //check time event
Disp=0;        //send displaytime signal to display time on the lcd

}

return 0;
}



void System_confi(void)
{
unsigned char i,Key_Get=0,Select=1;
Key_Get=Key_Return;//read key 

if((Display_Flag&0x01)&&(Key_Get==Long_SELECT)){
displayon();  //if display is off then trun on the led;and return
Display_Flag&=~0x01;
return;
}

if(Key_Get==Long_SELECT)
{
SOUND_WARNING_SIMPLE(); //sound and enter system config menu
for(i=0;i<120;i++){Buffer[i]=0x0;}; //clear second display buffer

Display_S=0;
Disp=1;
LCD_SetXY(0,7);
for(i=0;i<132;i++)WriteData(0);
LCD_Write_EnStr(0,7,"System"); 
LCD_Write_EnStr(50,7,"Set Time");

//do{Key_Get=Key_Return;}
//while(Key_Get==Long_SELECT||Key_Get==SELECT);

Disp=0;
flash=0;
while(1)
	{
	if(flash>50) 
	{   //if no key press and time out to return
	LCD_SetXY(0,7);
	for(i=0;i<128;i++)WriteData(0);
	Display_S=1;
	Disp=1;
	SOUND_RING2();
	break;
	};	
	if(Disp){
        if(Select==1){
		if(flash%2) //flash the select menu
			 LCD_Write_EnStr(0,7,"       ");
			else
			 LCD_Write_EnStr(0,7,"System ");
			 LCD_Write_EnStr(50,7,"Set Time ");
			 }
        if(Select==2){
		if(flash%2)
			 LCD_Write_EnStr(50,7,"         ");
			else
			 LCD_Write_EnStr(50,7,"Set Time ");
			 LCD_Write_EnStr(0,7,"System ");
			 }
	 Disp=0;
	 }
	 if(flash>5){
	 Key_Get=Key_Return;
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_ADD();Select=1;flash=0;}
	 if(Key_Get==LEFT){SOUND_DEC();Select=2;flash=0;}	
	 if(Key_Get==Long_LEFT)return;
     if((Key_Get==SELECT)||(Key_Get==Long_SELECT)){
	 								SOUND_ENTER();
	 								if(Select==1)configation(); //select the config button
									else Set_Time(); //select the set time button
									Display_S=1;
									Updata=1;
									initial_Alarm();//get new parameter
									return;
	 								}
	 }}
}
}

//limit the day of a month 
unsigned char hold_day(unsigned char month,unsigned char day)
{
if(day>30)
{
if((month==4)||(month==6)||(month==9)||(month==11))day=30;else day=31;
}

if((day>=29)&&(month==2))day=29;
return day;
}
////////////
//set time main funtion
void Set_Time(void)
{
unsigned char i,Key_Get,Temp,Month,Select;
Updata=0;

for(i=0;i<6;i++)twdata[i+1]=Time[i+1];
twdata[0]=0;

Send_Arial(24*2+5,1,0x30);

LCD_SetXY(0,7);
for(i=0;i<128;i++)WriteData(0);
LCD_Write_EnStr(0,7,"Set Hour --->");
LCD_SetXY(19*6,7);
LCD_Write_Char(asc[4]);
LCD_Write_Char(asc[5]);   //hour
Temp=(asc[4]&0x0F)*10;
Temp+=asc[5]&0x0F;
while(1){
		//flash the select
		if((flash>>1)&0x01){Send_Bank(0+5,1,Temp/10+0x30);Send_Bank(24+5,1,Temp%10+0x30);}
			else {Send_Arial(0+5,1,0x31);Send_Arial(24+5,1,0x31);}
		Key_Get=Key_Return;
	 if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();if(++Temp==24)Temp=0;flash=2;}
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();if(--Temp==0xFF)Temp=23;flash=2;}	
     if((Key_Get==SELECT)||(Key_Get==Long_SELECT)){
	 								SOUND_ENTER();
									twdata[2]=0;
									twdata[2]=Temp/10;
									twdata[2]<<=4;
									twdata[2]|=Temp%10;
									Send_Bank(0+5,1,Temp/10+0x30);
									Send_Bank(24+5,1,Temp%10+0x30);
									break;
	 								}
		}
LCD_SetXY(0,7);
for(i=0;i<128;i++)WriteData(0);
LCD_Write_EnStr(0,7,"Set Minute--->");
LCD_SetXY(19*6,7);
LCD_Write_Char(asc[2]);
LCD_Write_Char(asc[3]);
Temp=(asc[2]&0x0F)*10;  ///Minute
Temp+=asc[3]&0x0F;
while(1){
		
		if((flash>>1)&0x01){Send_Bank(24*3+5,1,Temp/10+0x30);Send_Bank(24*4+5,1,Temp%10+0x30);}
			else {Send_Arial(24*3+5,1,0x31);Send_Arial(24*4+5,1,0x31);}
		Key_Get=Key_Return;
	 if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();if(++Temp==60)Temp=0;flash=2;}
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();if(--Temp==0xFF)Temp=59;flash=2;}	
     if((Key_Get==SELECT)||(Key_Get==Long_SELECT)){
	 								SOUND_ENTER();
									twdata[1]=0;
									twdata[1]=Temp/10;
									twdata[1]<<=4;
									twdata[1]|=Temp%10;
									Send_Bank(24*3+5,1,Temp/10+0x30);
									Send_Bank(24*4+5,1,Temp%10+0x30);
									break;
	 								}
		}

LCD_SetXY(0,7);
for(i=0;i<128;i++)WriteData(0);
LCD_Write_EnStr(0,7,"Set Month--->");
LCD_SetXY(19*6,7);
LCD_Write_Char(asc[8]);
LCD_Write_Char(asc[9]);
Temp=(asc[8]&0x0F)*10; //month
Temp+=asc[9]&0x0F;
while(1){
		
		if((flash>>1)&0x01){Display_Big(0,5,Temp/10+0x30);Display_Big(8,5,Temp%10+0x30);}
			else {Display_Big(0,5,' ');Display_Big(8,5,' ');}
		Key_Get=Key_Return;
	 if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();if(++Temp==13)Temp=1;flash=2;}
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();if(--Temp==0x0)Temp=12;flash=2;}	
     if((Key_Get==SELECT)||(Key_Get==Long_SELECT)){
	 								SOUND_ENTER();
									twdata[4]=0;
									twdata[4]=Temp/10;
									twdata[4]<<=4;
									twdata[4]|=Temp%10;
									Month=Temp;
									Display_Big(0,5,Temp/10+0x30);
									Display_Big(8,5,Temp%10+0x30);
									break;
	 								}
		}
LCD_SetXY(0,7);
for(i=0;i<128;i++)WriteData(0);
LCD_Write_EnStr(0,7,"Set Day --->");
LCD_SetXY(19*6,7);
LCD_Write_Char(asc[6]);
LCD_Write_Char(asc[7]);
Temp=(asc[6]&0x0F)*10;
Temp+=asc[7]&0x0F;  //day
while(1){
		
		if((flash>>1)&0x01){Display_Big(32,5,Temp/10+0x30);Display_Big(40,5,Temp%10+0x30);}
			else {Display_Big(32,5,' ');Display_Big(40,5,' ');}
		Key_Get=Key_Return;
	 if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();if(++Temp==32)Temp=1;Temp=hold_day(Month,Temp);flash=2;}
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();if(--Temp==0x0)Temp=31;Temp=hold_day(Month,Temp);flash=2;}	
     if((Key_Get==SELECT)||(Key_Get==Long_SELECT)){
	 								SOUND_ENTER();
									twdata[3]=0;
									twdata[3]=Temp/10;
									twdata[3]<<=4;
									twdata[3]|=Temp%10;
									Display_Big(32,5,Temp/10+0x30);
									Display_Big(40,5,Temp%10+0x30);
									break;
	 								}
		}
LCD_SetXY(0,7);
for(i=0;i<128;i++)WriteData(0);
LCD_Write_EnStr(0,7,"Set Week  --->");
LCD_SetXY(19*6,7);
i=Time[5]&0x0F;
LCD_Write_Char(i+0x30);
Temp=Time[5]&0x0F;  //week
while(1){
		
		if((flash>>1)&0x01){Display_week(Temp);}
			else {Display_week(' ');}
		Key_Get=Key_Return;
	 if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();if(++Temp==8)Temp=1;flash=2;}
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();if(--Temp==0x0)Temp=7;flash=2;}	
     if((Key_Get==SELECT)||(Key_Get==Long_SELECT)){
	 								SOUND_ENTER();
									twdata[5]=0;
									twdata[5]=Temp&0x0F;
									twdata[6]=Time[6];//year not charge..
									Display_week(Temp);
									Key_Return=0;
									break;
	 								}
		}
twdata[0]=0;
LCD_SetXY(0,7);
for(i=0;i<128;i++)WriteData(0);
SOUND_RING1();
LCD_Write_EnStr(0,7,"OK     ");
LCD_Write_EnStr(45,7,"Cancel ");
Select=2;
	while(1)
		{
        if(Select==1){
		if(flash%2)
			 LCD_Write_EnStr(0,7,"       ");
			else
			 LCD_Write_EnStr(0,7,"OK     ");
			 LCD_Write_EnStr(45,7,"Cancel ");
			 }
        if(Select==2){
		if(flash%2)
			 LCD_Write_EnStr(45,7,"        ");
			else
			 LCD_Write_EnStr(45,7,"Cancel ");
			 LCD_Write_EnStr(0,7,"OK     ");
			 }
		Key_Get=Key_Return;
		if((Key_Get==Long_SELECT)){
		if(Select==1){
			//if select is 'ok' then set parameter to the DS1302
			SOUND_WARNING_TOOHIGH();
			Set1302();
			return;
			}
		else {SOUND_WARNING_TOOLOW();return;}
			}
	 if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_ADD();Select=1;}
	 if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_DEC();Select=2;}	

		}

}

////////////////////////////////////////////////////////////
//display something about the systems 
void Display_System(void)
{
unsigned char Key_Get=1;
while(Key_Get){
LCD_Write_EnStr(0,1,"  Atxmega64a3    ");
LCD_Write_EnStr(0,2,"Time Form RTC    ");
LCD_Write_EnStr(0,3,"LCD :OLED 128*64 ");
LCD_Write_EnStr(0,4,"Design By longNan");
LCD_Write_EnStr(0,5,"Any Question Emain");
LCD_Write_EnStr(0,6,"lisn3188@163.com");
LCD_Write_EnStr(0,7,"Press OK Return");

if((Key_Return==Long_SELECT)||(Key_Return==SELECT))Key_Get=0;

}
SOUND_WARNING_TOOLOW();
ini_dis();
}
////////////////////////////////////////////////////////////
///set lcd contrast funtion 
//set the parameter and write to the lcd controller 
//then save the parameter into eeprom 
void Set_contrast(void)
{
unsigned char i,Temp,Key_Get,flag=1;
 
Temp=EEPROM_ReadByte_(contrast);
while(1){
if(flag){
flag=0;
ini_dis();
LCD_Write_EnStr(0,3,"Press OK To Set..");
LCD_SetXY(0,7);
for(i=0;i<Temp;i++)WriteData(0xff);
if((Temp-24)>0)i=Temp-24;
	else i=0;
Display_Big(i,5,Temp/100+0x30);
Display_Big(i+8,5,Temp%100/10+0x30);
Display_Big(i+16,5,Temp%100%10+0x30);
Set_Contrast(Temp);
}
Key_Get=Key_Return;
if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();flag=1;if(++Temp>120)Temp=1;}
if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();flag=1;if(--Temp<1)Temp=119;}
if((Key_Get==Long_SELECT)||(Key_Get==SELECT)){SOUND_ENTER();

EEPROM_WriteByte_(contrast,Temp);
ini_dis();
return;
}
}
}
/////
//set time include hour and minutes 
//return with an interge 
unsigned int Set_Power_time(unsigned int in,unsigned char mode)
{
unsigned char i,Key_Get,Hour,Min,select=1,mode_s=0;
unsigned int temp=0;

Hour=in/256;
Min=in%256;

if(mode==1)
mode_s=Alarm_set_mode1;
else if(mode==2)mode_s=Alarm_set_mode2;

while(1)
{
if((flash>>1)&0x01){
LCD_SetXY(0,7);
for(i=0;i<80;i++)WriteData(0x00);
LCD_SetXY(30,7);
LCD_Write_Char(Hour/10+0x30);LCD_Write_Char(Hour%10+0x30);
LCD_Write_Char(':');LCD_Write_Char(Min/10+0x30);
LCD_Write_Char(Min%10+0x30); 
if(mode)display_mode(mode_s);
}
else{
LCD_SetXY(0,7);
for(i=0;i<80;i++)WriteData(0x00);
LCD_SetXY(30,7);
if(select==1){
LCD_Write_Char(' ');LCD_Write_Char(' ');
LCD_Write_Char(':');LCD_Write_Char(Min/10+0x30);
LCD_Write_Char(Min%10+0x30); 
}else if(select==2){
LCD_Write_Char(Hour/10+0x30);LCD_Write_Char(Hour%10+0x30);
LCD_Write_Char(':');LCD_Write_Char(' ');
LCD_Write_Char(' '); 
}else if(select==3){
LCD_Write_Char(Hour/10+0x30);LCD_Write_Char(Hour%10+0x30);
LCD_Write_Char(':');LCD_Write_Char(Min/10+0x30);
LCD_Write_Char(Min%10+0x30); LCD_Write_Char(' '); 
display_mode(4);
}
}
Key_Get=Key_Return;
if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();flash=2;
if(select==1){if(++Hour==24)Hour=0;}
if(select==2){if(++Min==60)Min=0;}
if(select==3){if(++mode_s==4)mode_s=0;}
temp=Hour*256+Min;
}
if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();flash=2;
if(select==1){if(--Hour==0xff)Hour=23;}
if(select==2){if(--Min==0xff)Min=59;}
if(select==3){if(--mode_s==0xff)mode_s=0;}
temp=Hour*256+Min;
}
if((Key_Get==Long_SELECT)||(Key_Get==SELECT)){SOUND_ENTER();
//display all data
LCD_SetXY(30,7);
LCD_Write_Char(Hour/10+0x30);LCD_Write_Char(Hour%10+0x30);
LCD_Write_Char(':');LCD_Write_Char(Min/10+0x30);
LCD_Write_Char(Min%10+0x30); 
if(mode)display_mode(mode_s);
//
if(mode==0){
if(++select==3){return temp;}
}
else{
if(++select==4){
if(mode==1)
Alarm_set_mode1=mode_s;
else if(mode==2)Alarm_set_mode2=mode_s;
return temp;}
}
}

}
}
///////////////////////////////////////////////////////////////
///set power mode include auto on and auto off time 
// then save the parameter to eeprom  can also power off rightnow
void Set_Power(void)
{
unsigned char i,Key_Get,flag=1,Select=2;
unsigned char Po_Hour,Po_Min,Pff_Hour,Pff_Min;
unsigned int temp,temp2;

 
Po_Hour=EEPROM_ReadByte_(P_on_hour);
if(Po_Hour>23)Po_Hour=0;
 
Po_Min=EEPROM_ReadByte_(P_on_min);
if(Po_Min>59)Po_Min=0;
 
Pff_Hour=EEPROM_ReadByte_(P_off_hour);
if(Pff_Hour>23)Pff_Hour=0;
 
Pff_Min=EEPROM_ReadByte_(P_off_min);
if(Pff_Min>59)Pff_Min=0;

ini_dis();
LCD_Write_EnStr(20,2,"Power On At :");
LCD_Write_EnStr(20,3,"Power Off At:");
LCD_Write_EnStr(20,4,"Power Off Now");
LCD_Write_EnStr(20,5,"Save&Return");
LCD_Write_EnStr(20,6,"Return");

while(1){

if(flag){
flag=0;
for(i=2;i<7;i++){LCD_Write_EnStr(0,i,"   ");}
LCD_Write_EnStr(0,Select,">>>");
LCD_SetXY(0,7);
for(i=0;i<120;i++)WriteData(0x00);

LCD_SetXY(30,7);
switch(Select){
case 2: LCD_Write_Char(Po_Hour/10+0x30);LCD_Write_Char(Po_Hour%10+0x30);
		LCD_Write_Char(':');LCD_Write_Char(Po_Min/10+0x30);
		LCD_Write_Char(Po_Min%10+0x30);LCD_Write_Char(' '); break;
case 3: LCD_Write_Char(Pff_Hour/10+0x30);LCD_Write_Char(Pff_Hour%10+0x30);
		LCD_Write_Char(':');LCD_Write_Char(Pff_Min/10+0x30);
		LCD_Write_Char(Pff_Min%10+0x30); LCD_Write_Char(' ');break;
case 4: LCD_Write_EnStr(0,7,"Press OK Poweroff"); break;
case 5: LCD_Write_EnStr(0,7,"Save And Return  "); break;
case 6: LCD_Write_EnStr(0,7,"      Return     "); break;
}
}
Key_Get=Key_Return;
if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();flag=1;if(++Select==7)Select=2;}
if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();flag=1;if(--Select==1)Select=6;}
if((Key_Get==Long_SELECT)||(Key_Get==SELECT)){
SOUND_ENTER();
switch(Select){
case 2: {
temp=Po_Hour*256+Po_Min;
temp2=Set_Power_time(temp,0);
Po_Hour=temp2/256;
Po_Min=temp2%256;
break;}
case 3: {
temp=0;
temp=Pff_Hour*256+Pff_Min;//
temp2=Set_Power_time(temp,0);
Pff_Hour=temp2/256;
Pff_Min=temp2%256;
break;}
case 4: ini_dis();SOUND_RING3(); Display_Flag|=0x01;displayoff();return;
case 5: {
 
EEPROM_WriteByte_(P_on_hour,Po_Hour);
 
EEPROM_WriteByte_(P_on_min,Po_Min);
 
EEPROM_WriteByte_(P_off_hour,Pff_Hour);
 
EEPROM_WriteByte_(P_off_min,Pff_Min);
SOUND_RING3();
ini_dis();
return;
}
case 6: SOUND_RING3();ini_dis();return;
}
}
}
}
////////////////////////////////////////////////////
//display the alarm mode
void display_mode(unsigned char mode)
{
switch(mode){
case 0: LCD_Write_EnStr(82,7,"Evryday ");break;
case 1: LCD_Write_EnStr(82,7,"Week1-5 ");break;
case 2: LCD_Write_EnStr(82,7,"Week1-6 ");break;
case 3: LCD_Write_EnStr(82,7,"alarmoff ");break;
default:LCD_Write_EnStr(82,7,"         ");break;
}

}
//////////////////////////////////////////////////////////
//set alarm time and mode then save to eeprom
void set_alarm(void)
{
unsigned char i,Key_Get,flag=1,Select=2;
unsigned char Po_Hour,Po_Min,Pff_Hour,Pff_Min;
unsigned int temp,temp2;

 
Po_Hour=EEPROM_ReadByte_(alarm1_hour);
if(Po_Hour>23)Po_Hour=0;
 
Po_Min=EEPROM_ReadByte_(alarm1_min);
if(Po_Min>59)Po_Min=0;
 
Pff_Hour=EEPROM_ReadByte_(alarm2_hour);
if(Pff_Hour>23)Pff_Hour=0;
 
Pff_Min=EEPROM_ReadByte_(alarm2_min);
if(Pff_Min>59)Pff_Min=0;

 
Alarm_set_mode1=EEPROM_ReadByte_(alarm1_mode);
if(Alarm_set_mode1>4)Alarm_set_mode1=0;
 
Alarm_set_mode2=EEPROM_ReadByte_(alarm2_mode);
if(Alarm_set_mode2>4)Alarm_set_mode2=0;

ini_dis();
LCD_Write_EnStr(20,2,"Alarm Group 1:");
LCD_Write_EnStr(20,3,"Alarm Group 2:");
LCD_Write_EnStr(20,4,"Save&Return");
LCD_Write_EnStr(20,5,"Return");

while(1){

if(flag){
flag=0;
for(i=2;i<6;i++){LCD_Write_EnStr(0,i,"   ");}
LCD_Write_EnStr(0,Select,">>>");
LCD_SetXY(0,7);
for(i=0;i<120;i++)WriteData(0x00);

LCD_SetXY(30,7);
switch(Select){
case 2: LCD_Write_Char(Po_Hour/10+0x30);LCD_Write_Char(Po_Hour%10+0x30);
		LCD_Write_Char(':');LCD_Write_Char(Po_Min/10+0x30);
		LCD_Write_Char(Po_Min%10+0x30); display_mode(Alarm_set_mode1);break;
case 3: LCD_Write_Char(Pff_Hour/10+0x30);LCD_Write_Char(Pff_Hour%10+0x30);
		LCD_Write_Char(':');LCD_Write_Char(Pff_Min/10+0x30);
		LCD_Write_Char(Pff_Min%10+0x30);display_mode(Alarm_set_mode2); break;
case 4: LCD_Write_EnStr(0,7,"Save And Return    "); break;
case 5: LCD_Write_EnStr(0,7,"      Return       "); break;
}
}
Key_Get=Key_Return;
if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();flag=1;if(++Select==6)Select=2;}
if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();flag=1;if(--Select==1)Select=5;}
if((Key_Get==Long_SELECT)||(Key_Get==SELECT)){
SOUND_ENTER();
switch(Select){
case 2: {
temp=Po_Hour*256+Po_Min;
temp2=Set_Power_time(temp,1);
Po_Hour=temp2/256;
Po_Min=temp2%256;
break;}
case 3: {
temp=Pff_Hour*256+Pff_Min;
temp2=Set_Power_time(temp,2);
Pff_Hour=temp2/256;
Pff_Min=temp2%256;
break;}
case 4: {
 
EEPROM_WriteByte_(alarm1_hour,Po_Hour);
 
EEPROM_WriteByte_(alarm1_min,Po_Min);
 
EEPROM_WriteByte_(alarm2_hour,Pff_Hour);
 
EEPROM_WriteByte_(alarm2_min,Pff_Min);

 
EEPROM_WriteByte_(alarm1_mode,Alarm_set_mode1);
 
EEPROM_WriteByte_(alarm2_mode,Alarm_set_mode2);
SOUND_RING3();
ini_dis();
return;
}
case 5: SOUND_RING3();ini_dis();return;
}
}
}
}
//////////////////////////////////////////////////////////
//main funtion for systems config
//include alarm set 
//power set
//contrast set
//look some thing about the systems
void configation(void)
{
unsigned char i,Key_Get,Temp=1,Select=1;
Updata=0;
ini_dis();
LCD_Write_EnStr(30,1,"Alarm Set");
LCD_Write_EnStr(30,2,"Power Set");
LCD_Write_EnStr(30,3,"Contrast Set");
LCD_Write_EnStr(30,4,"About ");
LCD_Write_EnStr(30,5,"Return&Back");
while(1){
if(Temp){
Temp=0;
LCD_Write_EnStr(10,Select,">>>");
switch(Select){
case 1:LCD_Write_EnStr(0,6,"Press Enter Set The");
 	   LCD_Write_EnStr(0,7,"Two Group for Alarm"); break;
case 2:LCD_Write_EnStr(0,6,"Press Enter Set The");
 	   LCD_Write_EnStr(0,7,"System Power Config"); break;
case 3:LCD_Write_EnStr(0,6,"Press Enter Set The");
 	   LCD_Write_EnStr(0,7," Display Contrast"); break;
case 4:LCD_Write_EnStr(0,6,"Press Enter See The");
 	   LCD_Write_EnStr(0,7,"Some About System"); break;
case 5:LCD_Write_EnStr(0,6,"Press Enter Back To");
 	   LCD_Write_EnStr(0,7,"The Display Interface"); break;
}
}
Key_Get=Key_Return;
if((Key_Get==Long_LEFT)||(Key_Get==LEFT)){SOUND_ADD();Temp=1;for(i=1;i<6;i++){
							LCD_Write_EnStr(10,i,"   ");
								}if(++Select==6)Select=1;}
if((Key_Get==Long_RIGHT)||(Key_Get==RIGHT)){SOUND_DEC();Temp=1;for(i=1;i<6;i++){
							LCD_Write_EnStr(10,i,"   ");
								}if(--Select==0x0)Select=5;}
if((Key_Get==Long_SELECT)||(Key_Get==SELECT)){SOUND_ENTER();
ini_dis();
switch(Select){
case 1: set_alarm();return;
case 2: Set_Power();return;
case 3: Set_contrast();return;
case 4: Display_System();return;
case 5: SOUND_RING3();ini_dis();return;
}
}
}
}
/*
+------------------------------------------------------------------------------
| Function    : interrput 
+------------------------------------------------------------------------------
| Description : interrput for TCC1 overflow,tig the LED1
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
ISR(TCC1_OVF_vect)  
{
unsigned char j;

flash++;

if((Disp==0)&&Updata&&(Display_Flag==0))
{

Send_Bank(0+5,1,asc[4]);
Send_Bank(24+5,1,asc[5]);
Send_Bank(24*3+5,1,asc[2]);
Send_Bank(24*4+5,1,asc[3]);

if(asc[1]%2){
Send_Arial(24*2+5,1,0x30);
}else {Send_Arial(24*2+5,1,0x31);}

if(Display_S){

j=(asc[0]&0x0F)*10;
j+=asc[1]&0x0f;
Display_Second(j,Time[1]);

LCD_SetXY(120,7);
//LCD_Write_Char(asc[0]);
LCD_Write_Char(asc[1]);


}

Display_Date(Time[4],Time[3],Time[5]);
Disp=1;
}

}



ISR(NVM_EE_vect) 
{ 
    

   /* Disable the EEPROM interrupt */ 
   NVM.INTCTRL = (NVM.INTCTRL & ~NVM_EELVL_gm); 
    
   /* only for test */ 
   /* turn led off  */ 
   //   LED_AUS 
} 
