#include "avr/io.h"

//--------------------------------------------------------------------
 #define SELECT   0x01
 #define LEFT     0x02
 #define RIGHT    0x04
 #define UP       0x08
 #define DOWN     0x10


 #define RSELECT   0x01
 #define RLEFT     0x02
 #define RRIGHT    0x03
 #define RUP       0x04
 #define RDOWN     0x05
 
 #define RLong_SELECT   0x06
 #define RLong_LEFT     0x07
 #define RLong_RIGHT    0x08
 #define RLong_UP       0x09
 #define RLong_DOWN     0x0a
 
 
 #define Longnop() NOP();NOP();NOP();NOP();NOP();NOP();NOP();NOP();NOP();

 #define Short_Key_16ms 3     //160ms
 #define Long_Key_16ms  100     //2S
 #define Long_Sure      Long_Key_16ms+10
//---------------------------------------------------------------
unsigned char   Key_Time_SELECT=0,
 				Key_Time_LEFT=0,
				Key_Time_RIGHT=0,
				Key_Time_UP=0,
 				Key_Time_DOWN=0;
unsigned long system_tick=0;
unsigned char Key_Return=0;
//---------------------------------------------------------------
void KEY_initial(void)
{
PORTE.DIR&=~0x1f;
PORTE.PIN0CTRL=PORT_OPC_PULLUP_gc;
PORTE.PIN1CTRL=PORT_OPC_PULLUP_gc;
PORTE.PIN2CTRL=PORT_OPC_PULLUP_gc;
PORTE.PIN3CTRL=PORT_OPC_PULLUP_gc;
PORTE.PIN4CTRL=PORT_OPC_PULLUP_gc;
}
//---------------------------------------------------------------
unsigned char Get_Key(void)
{
	unsigned char Key=0,num_keypress=0;
	if((PORTE.IN&(1<<1))==0){Key|=SELECT;num_keypress++;}
	if((PORTE.IN&(1<<0))==0){Key|=LEFT;num_keypress++;}
	if((PORTE.IN&(1<<4))==0){Key|=RIGHT;num_keypress++;}
	if((PORTE.IN&(1<<2))==0){Key|=UP;num_keypress++;}
	if((PORTE.IN&(1<<3))==0){Key|=DOWN;num_keypress++;}
	if(num_keypress>1)Key=0;
	return Key;
}

//---------------------------------------------------------------