

#include "Pixel_EN.h"
#include "avr/io.h"



//
#define LCD_X_RES		84
#define LCD_Y_RES		48
#define DC_CMD           0	//д
#define DC_DATA          1  //д

#define u8  unsigned char
// ܽ H: high, L: low
// For XMEGA

#define LCD_CTRL_PORT	PORTE.OUT
#define LCD_RST			0x20
#define LCD_CE			0x08
#define LCD_DC			0x01
#define LCD_MOSI		0x02
#define LCD_CLK			0x04
#define LCD_LED         0x10

#define LCD_RST_H		LCD_CTRL_PORT|=LCD_RST
#define LCD_RST_L		LCD_CTRL_PORT&=~LCD_RST

#define LCD_CE_H		LCD_CTRL_PORT|=LCD_CE
#define LCD_CE_L		LCD_CTRL_PORT&=~LCD_CE

#define LCD_DC_DATA		LCD_CTRL_PORT|=LCD_DC
#define LCD_DC_CMD		LCD_CTRL_PORT&=~LCD_DC

#define LCD_MOSI_H		LCD_CTRL_PORT|=LCD_MOSI
#define LCD_MOSI_L		LCD_CTRL_PORT&=~LCD_MOSI

#define LCD_CLK_H		LCD_CTRL_PORT|=LCD_CLK
#define LCD_CLK_L		LCD_CTRL_PORT&=~LCD_CLK



/**************************************************************/

const u8 Big_Num[]=
{
0xFE,0xFF,0x03,0x03,0x03,0xFF,0xFE,0x00,
0x7F,0xFF,0xC0,0xC0,0xC0,0xFF,0x7F,0x00,
0x00,0x00,0x00,0xFE,0xFF,0x00,0x00,0x00,
0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,
0x8F,0xCF,0xC3,0xC3,0xC3,0xFF,0x7E,0x00,
0xFF,0xFF,0xC0,0xC0,0xC0,0xF0,0xF0,0x00,
0x0F,0x0F,0xC3,0xC3,0xC3,0xFF,0xFE,0x00,
0xF0,0xF0,0xC0,0xC0,0xC0,0xFF,0x7F,0x00,
0xFE,0xFE,0x00,0x00,0xFF,0xFF,0x00,0x00,
0x01,0x03,0x03,0x03,0xFF,0xFF,0x03,0x00,
0xFF,0xFF,0xC3,0xC3,0xC3,0xCF,0x8F,0x00,
0x30,0xF0,0xC0,0xC0,0xC0,0xFF,0x7F,0x00,
0xFE,0xFF,0x63,0x63,0x63,0xE7,0xC7,0x00,
0x7F,0xFF,0xC0,0xC0,0xC0,0xFF,0x7F,0x00,
0x0F,0x0F,0x03,0x03,0x03,0xFF,0xFE,0x00,
0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
0x3E,0xFF,0xC3,0xC3,0xC3,0xFF,0x3E,0x00,
0x7F,0xFF,0xC0,0xC0,0xC0,0xFF,0x7F,0x00,
0xFE,0xFF,0x03,0x03,0x03,0xFF,0xFE,0x00,
0xF1,0xF3,0xC3,0xC3,0xC3,0xFF,0x7F,0x00
} ;


/*************************************************************/
void LCD_Send(u8 data, u8 dc);
void LCD_SetXY(u8 X, u8 Y);
void LCD_Clear(void);

//-------------------------------------------------------------------
//	Nokia5510ָ
//  D7  D6  D5  D4  D3  D2  D1  D0
//  0   0   1   0   0   PD  V   H
//                      |   |   |_______1->չָ  0->ָ
//                      |   |___________1->ֱѰַ    0->ˮƽѰַ 
//                      |_______________1->͹ģʽ  0->ģʽ
//-------------------------------------------------------------------
//	ʾģʽ
//  D7  D6  D5  D4  D3  D2  D1  D0
//  0   0   0   0   1   D   0   E
//                      |       |_______0    0    1    1
//                      |_______________0    1    0    1
//                                        ȫ ת
//-------------------------------------------------------------------
void Wait_ms(void)
{
	unsigned long i=0x0Ffff;
	while (i--);
}
void Delay_us(void)
{
 	unsigned char i=1;
	while (i--);

}

// LCDԱȶ(ԱȶȷΧ: 0~127)
void LCD_SetContrast(u8 contrast)
{
    LCD_Send(0x21, DC_CMD);
    LCD_Send(0x80 | contrast, DC_CMD);
    LCD_Send(0x20, DC_CMD);
}

// LCDʼ
void LCD_Init(void)
{
  /*		LCD3310				  */
	PORTE.DIR|=0x3F;
	PORTE.OUT|=LCD_LED;
	LCD_RST_L;	//λLCD_͵ƽ	
	Wait_ms();
	Wait_ms();
	Wait_ms();
	Wait_ms();
	LCD_RST_H;
	

	//LCD
    LCD_Send(0x21, DC_CMD);	//ʹչLCDģʽ
    LCD_Send(0xC8, DC_CMD);	//ƫõѹ
    LCD_Send(0x06, DC_CMD);	//¶У
    LCD_Send(0x13, DC_CMD);	//1:48
    LCD_Send(0x20, DC_CMD);	//ʹû
    LCD_Send(0x0C, DC_CMD);	//趨ʾģʽʾ
	LCD_SetContrast(65);
	LCD_Clear();

}



// LCDǰ
void LCD_SetXY(u8 X, u8 Y)
{
	if (X>5) return;
	if (Y>83) return;
	
	LCD_Send(0x40 | X, DC_CMD);    // 
    LCD_Send(0x80 | Y, DC_CMD);    // 
}

// LCD
void LCD_Clear(void)
{
	unsigned int i;
	
	LCD_Send(0x0c, DC_CMD);
    LCD_Send(0x80, DC_CMD);
	
	for (i=0; i<504; i++)
		LCD_Send(0, DC_DATA);	
}

// LCD
void LCD_Send(u8 data, u8 dc)
{
	u8 i=8;
	LCD_CE_L; //Enable LCD
	if (dc==DC_CMD)
		LCD_DC_CMD;	//
	else
		LCD_DC_DATA;//
	Delay_us();
	while (i--)
	{
		LCD_CLK_L;
		if(data&0x80)
			LCD_MOSI_H;	/* MSB first */
		else 
			LCD_MOSI_L;
		LCD_CLK_H;
		data <<= 1;		/* Data shift */
		Delay_us();
	}
	Delay_us();	
	LCD_CE_H; //Disable LCD
}

// LCDдһӢַ
void LCD_Write_Char(u8 ascii)
{
    u8 n;
	
    ascii -= 32; //ASCII-32
	
    for (n=0; n<6; n++)
		LCD_Send(Font6x8[ascii][n], DC_DATA);
}

// LCDдӢַ
void LCD_Write_EnStr(u8 X, u8 Y, char* s)
{
    LCD_SetXY(X,Y);
    while (*s) 
	{
		LCD_Write_Char(*s++);
	}
}
/*
// LCDдַ
void LCD_Write_ChStr(u8 X, u8 Y, u8 num)
{
    u8 i,n;
    for (n=0; n<num; n++)
	{
		LCD_SetXY(X, Y);
		for (i=0; i<12; i++)
			LCD_Send(CH12x12[n][i], DC_DATA); //ϰ
		Y += 1;
		LCD_SetXY(X, Y);
		for (i=0; i<12; i++)
			LCD_Send(CH12x12[n][i+12], DC_DATA); //°
		Y -= 1;
		X += 12;
	}
}
*/


 /*-----------------------------------------------------------------------
LCD_draw_map      : λͼƺ

XY    λͼƵʼXYꣻ
          *map    λͼݣ
          Pix_x   λͼأ
          Pix_y   λͼأ

д          2004-8-13
޸      2004-8-13 
-----------------------------------------------------------------------*/

void LCD_draw_bmp_pixel(unsigned char X,unsigned char Y,const u8* map,
                  unsigned char Pix_x,unsigned char Pix_y)
  {
    unsigned int i,n,buffer;
    unsigned char row;
	u8 j=8,data;
    if(Pix_y%8==0) row=Pix_y/8;      //λͼռ
      else


        row=Pix_y/8+1;
    
    for (n=0;n<row;n++)
      {
      	LCD_SetXY(X+n,Y);      //

		buffer=Pix_x*n;
        for(i=0; i<Pix_x; i++)
          {
            data=map[i+buffer];
			j=8;	
			LCD_CE_L; //Enable LCD
			LCD_DC_DATA;//
			Delay_us();
			while (j--)
			{
				LCD_CLK_L;
				if(data&0x01)
					LCD_MOSI_H;	/* MSB first */
				else 
					LCD_MOSI_L;
				LCD_CLK_H;
				data >>= 1;		/* Data shift */
				Delay_us();
			}
			Delay_us();	
			LCD_CE_H; //Disable LCD
          }
                               
      }      
  }

void Display_Big_Number(u8 X,u8 Y,unsigned char Number)
{
    LCD_SetXY(X,Y);

	LCD_Write_Char(Number/100+0x30);
	LCD_Write_Char(Number%100/10+0x30);
	LCD_Write_Char(Number%10+0x30);
}



