/*
+------------------------------------------------------------------------------
| Project   : Timer Test for Xmega3_DEMO
+------------------------------------------------------------------------------
| Copyright 2010  www.chiplab7.com (lisn3188@163.com)
| All rights reserved.
|------------------------------------------------------------------------------
| File      : Timer.c, Timer operation demo 
|------------------------------------------------------------------------------
| Chang Logs:
| Date           Author           Notes
| 2010-06-22     lisn3188         The first version.                     
+------------------------------------------------------------------------------
*/
#include <avr/io.h>
#include <avr/interrupt.h>

#define LED1_ON()   PORTC.OUT&=~0x01
#define LED1_OFF()  PORTC.OUT|=0x01
#define LED1_T()    PORTC.OUT^=0x01

#define LED2_ON()   PORTC.OUT&=~0x02
#define LED2_OFF()  PORTC.OUT|=0x02
#define LED2_T()    PORTC.OUT^=0x02

/*
+------------------------------------------------------------------------------
| Function    : Initial_Timer
+------------------------------------------------------------------------------
| Description : initial the Timer 
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
void Initial_Timer(void)
{
TCC1.PER=976;  //500ms (2M/1024/2)
TCC1.INTCTRLA=TC_OVFINTLVL_LO_gc;//Enable Timer Overflow interrupt
/* Select clock source. 1024Div 2M/1024= 1.95K*/
TCC1.CTRLA=TC_CLKSEL_DIV1024_gc;
PMIC.CTRL |= PMIC_LOLVLEN_bm; //enable low_level interrupts
}

/*
+------------------------------------------------------------------------------
| Function    : main
+------------------------------------------------------------------------------
| Description : initail the TCC1 and Stop.wait the interrupt come.
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/

int main(void)
{

PORTC.DIR|=0x03; //Set Led Pin as Output
LED1_OFF();
LED2_OFF();
Initial_Timer();
sei();
while(1);  //Stop

return 0;
}

/*
+------------------------------------------------------------------------------
| Function    : interrput 
+------------------------------------------------------------------------------
| Description : interrput for TCC1 overflow,tig the LED1
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
ISR(TCC1_OVF_vect)  //
{
LED1_T();
}






