/*
+------------------------------------------------------------------------------
| Project   : USART Test for Xmega3_DEMO
+------------------------------------------------------------------------------
| Copyright 2010  www.chiplab7.com (lisn3188@163.com)
| All rights reserved.
|------------------------------------------------------------------------------
| File      : 
|------------------------------------------------------------------------------
| Chang Logs:
| Date           Author           Notes
| 2010-06-22     lisn3188         The first version.                     
+------------------------------------------------------------------------------
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "uart.h"

#define rx_interrupt  1  //use receive interrupt

#define LED1_ON()   PORTC.OUT&=~0x01
#define LED1_OFF()  PORTC.OUT|=0x01
#define LED1_T()    PORTC.OUT^=0x01

#define LED2_ON()   PORTC.OUT&=~0x02
#define LED2_OFF()  PORTC.OUT|=0x02
#define LED2_T()    PORTC.OUT^=0x02


/*
+------------------------------------------------------------------------------
| Function    : main
+------------------------------------------------------------------------------
| Description : test the Usarts
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
int main(void)
{

PORTC.DIR|=0x03; //Set Led Pin as Output
LED1_OFF(); //trun off the LED
LED2_OFF(); //trun off the LED
CLK.PSCTRL= (uint8_t)CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;//prescaler configuration
uart_init(); //initial the Usart
			 //9600 , n , 1
uart_putc('\n');
uart_putdw_hex(0x0fdd12);
uart_putc('\n');
uart_putdw_dec(1234567);
uart_putc('\n');
uart_puts("USART TEST...");
uart_putc('\n');

#if rx_interrupt
	uart_rx_interrupt();
	/* Enable interrupts. */
	PMIC.CTRL |= PMIC_LOLVLEN_bm; //Enable Low_Level interrupts
	sei();
	while(1);//stop
#else 
	while(1){
		uart_putc(uart_getc());
		LED1_T();
		}
#endif
return 0;
}

/*
+------------------------------------------------------------------------------
| Function    : ISR(USARTE1_RXC_vect)
+------------------------------------------------------------------------------
| Description : USARTE1 receive interrupt routine
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
ISR(USARTE1_RXC_vect)  //send back the data
{
unsigned char CH;
LED1_T();
CH=USARTE1.DATA;
 		do{
		/* Wait until it is possible to put data into TX data register.
		 * NOTE: If TXDataRegister never becomes empty this will be a DEADLOCK. */
		}while((USARTE1.STATUS & USART_DREIF_bm)==0);
USARTE1.DATA=CH;
}












